;  ##############################################################################################
;  ##                                                                                     ##
;  ##                                   FAMILIE 3.8                                       ##
;  ##                            Copyright  Dr. Arnim Wegner                             ##
;  ##                                                                                     ##
;  #########################################################################################
;
;  Dieses Programm ist freie Software; Sie knnen es unter den Bedingungen der GNU General
;  Public License, wie von der Free Software Foundation verffentlicht, weitergeben und/oder
;  modifizieren, entweder gem Version 2 der Lizenz oder (nach Ihrer Option) jeder spteren
;  Version. Die Verffentlichung dieses Programms erfolgt in der Hoffnung, dass es Ihnen von
;  Nutzen sein wird, aber OHNE IRGENDEINE GARANTIE, sogar ohne die implizite Garantie der
;  MARKTREIFE oder der VERWENDBARKEIT FR EINEN BESTIMMTEN ZWECK. Details finden Sie in der
;  GNU General Public License. Sie sollten eine Kopie der GNU General Public License zusam-
;  men mit diesem Programm erhalten haben. Falls nicht, schreiben Sie an die Free Software
;  Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA 02110-1301 USA oder an die
;  Free Software Foundation Europe e.V., Villa Vogelsang, Antonienallee 1, 45279 Essen.
;
;  This program is free software; you can redistribute it and/or modify it under the terms
;  of the GNU General Public License as published by the Free Software Foundation; either
;  version 2 of the License, or (at your option) any later version. This program is
;  distributed in the hope that it will be useful, but WITHOUT ANY WARRANTY; without even
;  the implied warranty of MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
;  GNU General Public License for more details. You should have received a copy of the GNU
;  General Public License along with this program; if not, write to the Free Software
;  Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA 02111-1307 USA, or to the Free
;  Software Foundation Europe e.V., Villa Vogelsang, Antonienallee 1, 45279 Essen, Germany.
;
;  #########################################################################################
;  ##                                                                                     ##
;  ##                       Quelltext geschrieben und kompiliert mit                      ##
;  ##                    PureBasic 4.30  Copyright  Fantaisie Software                   ##
;  ##                                                                                     ##
;  #########################################################################################
;
;- INITIALISIERUNG
;- Deklarationen
Declare Konfiguration()
Declare ConfigSpeichern(typ)
Declare DateiAnlegen()
Declare DateiOeffnen(typ)
Declare DateiSchliessen(typ)
Declare DatenInStruktur(k)
Declare StrukturInDaten(k)
Declare DateiSpeichern(typ)
Declare DateiUebernehmen()
Declare Liste()
Declare NeuDim()
Declare Initialisierung()
Declare Schreibschutz(d$,typ)
Declare Benutzername()
Declare Instanzreset()
Declare Programmende()
;
Declare Fensterauf()
;
Declare InitMenuGadget()
Declare SteuerungModus(mod)
Declare AdoptGadget(typ)
Declare DynGadgetWeg()
;
Declare VerbindungenAnzeigen(num)
Declare VerbindungenBearbeiten()
Declare Stammdaten()
Declare NeuePerson()
Declare Vorfahren()
Declare InfoPerson()
Declare Infotest()
Declare Suchen(typ)
;
Declare VerbindungHin(g)
Declare.i PartnerHin(p,neu,gad)
Declare.i VaterHin(p,neu)
Declare.i MutterHin(p,neu)
Declare.i KindHin(p,neu,gad)
Declare VerbindungWeg(g)
Declare PartnerWeg(p,gad)
Declare ElternWeg(p)
Declare KindWeg(p,gad)
Declare LueckenPartner(pp,lu)
Declare LueckenKinder(pp,lu)
Declare StammdatenBearb()
Declare NeuePersonBearb()
Declare VirtPartner(p)
Declare Entfernen(p,ab)
Declare VirtEntfernen()
Declare HinWeg(typ)
Declare Sortierung(typ)
;
Declare.i Zyklentest(p)
Declare.s NNnummer()
Declare.s ZZnummer()
Declare.s Prueftext()
Declare.i Datentest()
Declare.s Parse(f$,typ=0)
Declare.s GetFileName(f$)
Declare.i Max(x,y)
Declare.i Min(x,y)
;
Declare Info()
Declare Hilfe(typ,txt$="")
;- Konstanten
#zeilen=720
#spalten=980
#info=1000 ; Dieser Wert darf aus Kompatibilittsgrnden nicht verkleinert werden.
#fehler="ERROR"
;- Strukturen
Structure per
  nam.s
  vor.s
  gen.s
  geb.s
  ste.s
  vat.i[2]
  mut.i[2]
  fam.i[190]
  inf.s{#info+4}
EndStructure
;- Variable
Define.i
Global Dim Person.per(0)
Global Dim daten$(0)
Global Dim datenstart$(0)
Global Dim idx(0)
Global Dim inv(0)
Global Dim li$(0)
Global Dim prs(189)
Global Dim vor(511)
Global Dim kin(9)
Global Dim hges(9)
Global Dim hscr(9)
Global Dim bsub(9)
Global programmtitel$,programmtitelalt$,version$,versionalt$
Global fenstertitel$,pfad$,userdat$,userprg$,appenv$,appdat$,appdatalt$
Global WinID,datei$,ein$,fam$,hnd$,mup$,mua$,stamm$,datneu$
Global modus,instanz,perzahl,perzahlstart,pgad,weg,zykl,sort,progquit,exit$
;- Version
version$="3.8"
versionalt$="3.7"
programmtitel$="Familie"+Chr(32)+version$
programmtitelalt$="Familie"+Chr(32)+versionalt$
fenstertitel$=programmtitel$
;-
;- Programmstart
Konfiguration()
Fensterauf()
InitMenuGadget()
Liste()
Initialisierung()
HideWindow(0,0)
;
;- HAUPTSCHLEIFE
Repeat
  EventID=WaitWindowEvent()
  Select EventId
    Case #PB_Event_CloseWindow
      progquit=1
    Case #PB_Event_Gadget
      GadID=EventGadget()
      Select GadID
        Case 2
          pgd=GetGadgetState(2)+1
          If pgd>0
            pgad=pgd
            If modus=0
              SteuerungModus(1)
            EndIf
            If modus=1
              VerbindungenAnzeigen(idx(pgad))
            EndIf
          EndIf
        Case 5
          If modus=1
            Vorfahren()
          EndIf
        Case 8 To 189
          If modus=1
            VerbindungenAnzeigen(prs(GadID))
          ElseIf modus=2
            If weg=1
              VerbindungWeg(GadID)
            ElseIf pgad>0
              VerbindungHin(GadID)
            Else
              tit$="Verbindung hinzufgen"
              txt$="Whlen Sie eine Person aus der Personenliste aus !    "
              MessageRequester(tit$,txt$,#MB_ICONINFORMATION)
            EndIf
          EndIf
        Case 201
          Select modus
            Case 2
              For k=1 To perzahl
                StrukturInDaten(k)
              Next k
              SetGadgetState(2,-1)
            Case 3
              StammdatenBearb()
            Case 4
              NeuePersonBearb()
          EndSelect
          If prs(5)<>0
            VerbindungenAnzeigen(prs(5))
          Else
            Initialisierung()
          EndIf
        Case 202
          VerbindungenBearbeiten()
        Case 203
          Stammdaten()
        Case 204
          NeuePerson()
        Case 205
          Entfernen(prs(5),1)
        Case 272
          HinWeg(0)
        Case 273
          HinWeg(1)
        Case 276
          AdoptGadget(3)
        Case 277
          AdoptGadget(4)
        Case 296
          Sortierung(0)
        Case 297
          Sortierung(1)  
        Case 298
          Sortierung(2)  
        Case 301 To 427
          SteuerungModus(1)
          VerbindungenAnzeigen(vor(GadID-300))
      EndSelect
    Case #PB_Event_Menu
      MenID=EventMenu()
      Select MenID
        Case 11
          DateiAnlegen()
        Case 12
          DateiOeffnen(1)
        Case 13
          DateiSpeichern(2)
        Case 14
          DateiUebernehmen()
        Case 17
          Hilfe(2)
        Case 18
          Instanzreset()   
        Case 19
          progquit=1
        Case 21
          Benutzername()
        Case 31
          Suchen(1)
        Case 32
          Suchen(2)
        Case 33
          Suchen(3)  
        Case 41
          Hilfe(1)
        Case 49
          Info()
     EndSelect
  EndSelect
  Infotest()
  If progquit=1
    Programmende()
  EndIf
ForEver
;- Programmende
;-
;- KONFIGURATION
Procedure Konfiguration()
  tit$=programmtitel$+": Fehler beim Programmstart"
  exit$=Chr(13)+Chr(13)+programmtitel$+" wird beendet.    "
  ;
  pfad$=GetPathPart(ProgramFilename())
  userprg$=GetEnvironmentVariable("COMPUTERNAME")+"\"+GetEnvironmentVariable("USERNAME")
  If GetDriveType_(Left(pfad$,3))=#DRIVE_REMOVABLE    ; entfernbarer Datentrger
    appenv$=pfad$
    appdat$=appenv$+programmtitel$+"\"
    If FileSize(appdat$)=-1
      ; Anwendungsdatenverzeichnis erzeugen auf entfernbarem Datentrger:
      If CreateDirectory(appdat$)=0                   ; nicht beschreibbar:
        appenv$=GetEnvironmentVariable("APPDATA")+"\" ; doch auf Festplatte schreiben
        appdat$=appenv$+programmtitel$+"\"
        If FileSize(appdat$)=-1
          ; Anwendungsdatenverzeichnis erzeugen auf Festplatte:
          If CreateDirectory(appdat$)=0               ; auch nicht mglich: Programmende
            txt$="Das Verzeichnis "
            txt$+Chr(13)+appdat$+Space(4)+Chr(13)
            txt$+"konnte nicht erzeugt werden.    "+exit$
            MessageRequester(tit$,txt$,#MB_ICONSTOP)
            Programmende()
          EndIf
        EndIf     
      EndIf
    EndIf
  Else                                                ; Festplatte 
    appenv$=GetEnvironmentVariable("APPDATA")+"\"
    appdat$=appenv$+programmtitel$+"\"
    If FileSize(appdat$)=-1
      ; Anwendungsdatenverzeichnis erzeugen auf Festplatte:
      If CreateDirectory(appdat$)=0                   ;  nicht mglich: Programmende
        txt$="Das Verzeichnis "
        txt$+Chr(13)+appdat$+Space(4)+Chr(13)
        txt$+"konnte nicht erzeugt werden.    "+exit$
        MessageRequester(tit$,txt$,#MB_ICONSTOP)
        Programmende()
      EndIf
    EndIf     
  EndIf
  appdatalt$=appenv$
  mup$=pfad$+"Muster.fam"
  mua$=appdat$+"Muster.fam"
  hnd$=pfad$+"Handbuch.pdf"
  ein$=appdat$+"Einstellungen.ini"
  fam$=appdat$+"*.fam"
  ; 
  If OpenPreferences(ein$)
    PreferenceGroup("Startdatei")
      datei$=appdat$+ReadPreferenceString("Startdatei","")
    PreferenceGroup("Benutzer")
      userprg$=ReadPreferenceString("Benutzer",userprg$)
      If userprg$=""
        userprg$=GetEnvironmentVariable("COMPUTERNAME")+"\"+GetEnvironmentVariable("USERNAME")
      EndIf
    PreferenceGroup("Instanz")
      instanz=ReadPreferenceLong("Instanz",0)
    ClosePreferences()
    instanz+1
    ConfigSpeichern(2)
    If instanz>1
      fenstertitel$=programmtitel$+"  NUR ANZEIGEN"
    EndIf
  Else
    instanz=1
    ConfigSpeichern(0)
  EndIf
  ;
  If (FileSize(mup$)<>-1) And (FileSize(mua$)=-1)
    CopyFile(pfad$+"Muster.fam",appdat$+"Muster.fam")
  EndIf
  If FileSize(fam$)<0 ; immer noch keine Familiendatei in appdat$ vorhanden
    DateiAnlegen()
    If datneu$=""
      txt$+"Es wurde keine Familiendatei angelegt.    "+exit$
      MessageRequester(tit$,txt$,#MB_ICONSTOP)
      End
    EndIf
  EndIf
  ;
  tit$="Familiendatei ffnen"
  If FileSize(datei$)<0
    Repeat
      datei$=OpenFileRequester(tit$,fam$,"Familiendateien|*.fam",0)
      If datei$=""
        progquit=1
        Programmende()
      ElseIf GetExtensionPart(datei$)<>"fam"
        txt$="Eine Familiendatei muss die Dateiendung fam haben.    "
        MessageRequester(tit$,txt$,#MB_ICONSTOP)
      ElseIf FileSize(datei$)<0
        txt$="Eine Familiendatei "+GetFilePart(datei$)+" existiert nicht.    "
        MessageRequester(tit$,txt$,#MB_ICONSTOP)
      ElseIf FindString(datei$,version$,1)=0
        txt$="Die Familiendatei "+GetFilePart(datei$)+" befindet sich nicht im aktuellen Anwendungsdatenverzeichnis.    "
        MessageRequester(tit$,txt$,#MB_ICONSTOP)  
      Else
        quit=1
      EndIf
    Until quit=1
    ConfigSpeichern(0)
  EndIf
  ;
  If OpenPreferences(datei$)
    userdat$=ReadPreferenceString("benutzer","")
    If userdat$=""
       userdat$="?"
    EndIf
    If userdat$<>userprg$
      txt$+"Beim Programmstart ldt das Programm    "
      txt$+Chr(13)
      txt$+"die Familiendatei "+GetFilePart(datei$)+".    "
      txt$+Chr(13)
      txt$+"Diese Datei wurde zuletzt von einem    "
      txt$+Chr(13)
      txt$+"anderen Benutzer ("+userdat$+") bearbeitet.    "
      MessageRequester(programmtitel$,txt$,#MB_ICONINFORMATION)
    EndIf
    perzahl=ReadPreferenceLong("personenzahl",10000)
    perzahlstart=perzahl
    NeuDim()
    For k=1 To perzahl
      daten$(k)=ReadPreferenceString("p"+Str(k),"")
      datenstart$(k)=daten$(k)
      DatenInStruktur(k)
    Next k
    ClosePreferences()
  Else
    txt$="Die Familiendatei "+GetFilePart(datei$)+" konnte nicht geffnet werden.    "
    MessageRequester(programmtitel$,txt$,#MB_ICONSTOP)
    Programmende()
  EndIf
  ; altes Anwendungsdatenverzeichnis suchen
  drct=ExamineDirectory(#PB_Any,appenv$,programmtitelalt$)
  If drct>0
    While NextDirectoryEntry(drct)=1
      nd$=appenv$+DirectoryEntryName(drct)
      If FindString(nd$,version$,1)=0
        appdatalt$=nd$+"\"
      EndIf
    Wend
  EndIf
  FinishDirectory(drct)
EndProcedure ; Konfiguration
;
Procedure ConfigSpeichern(typ)
  tit$="Dateifehler"
  txt$="Die Datei Einstellungen.ini konnte nicht geschrieben werden.    "
  Schreibschutz(ein$,0)
  Select typ
    Case 0
      If CreatePreferences(ein$)
        PreferenceGroup("Version")
          WritePreferenceString("Version",version$) 
        PreferenceGroup("Startdatei")  
          WritePreferenceString("Startdatei",GetFilePart(datei$))
        PreferenceGroup("Benutzer")  
          WritePreferenceString("Benutzer",userprg$)
        PreferenceGroup("Instanz")
          WritePreferenceLong("Instanz",instanz)  
        ClosePreferences()
      Else
        MessageRequester(tit$,txt$,#MB_ICONSTOP)
      EndIf
    Case 1
      If OpenPreferences(ein$)
        PreferenceGroup("Version")
          WritePreferenceString("Version",version$) 
        PreferenceGroup("Startdatei")  
          WritePreferenceString("Startdatei",GetFilePart(datei$))
        PreferenceGroup("Benutzer")  
          WritePreferenceString("Benutzer",userprg$)  
        ClosePreferences()
      Else
        MessageRequester(tit$,txt$,#MB_ICONSTOP)
      EndIf
    Case 2
      If OpenPreferences(ein$) 
        PreferenceGroup("Instanz")
          WritePreferenceLong("Instanz",instanz)
        ClosePreferences()
      Else
        MessageRequester(tit$,txt$,#MB_ICONSTOP)
      EndIf
  EndSelect  
  Schreibschutz(ein$,1)
EndProcedure ; ConfigSpeichern
;
Procedure DateiAnlegen()
  tit$="Familiendatei anlegen"
  txt1$="Dateiname:"+Space(40)+"Abbruch: leerer Term"
  da$="*.fam"
  Repeat
    da$=InputRequester(tit$,txt1$,da$)
    da$=Trim(da$)
    dat$=appdat$+da$
    If da$=""
      ProcedureReturn
    ElseIf da$="*.fam" ; keine Reaktion
    ElseIf CheckFilename(da$)=0
      txt2$="Der angegebene Dateiname "+da$+" ist ungltig.    "
      MessageRequester(tit$,txt2$,#MB_ICONSTOP)
    ElseIf GetExtensionPart(da$)<>"fam"
      txt2$="Eine Familiendatei muss die Dateiendung fam haben.    "
      MessageRequester(tit$,txt2$,#MB_ICONSTOP)
    ElseIf FileSize(dat$)>0
      txt2$="Es gibt bereits eine Familiendatei "+da$+".    "
      MessageRequester(tit$,txt2$,#MB_ICONSTOP)
    Else
      quit=1
    EndIf
  Until quit=1
  If CreatePreferences(dat$)
    PreferenceComment(programmtitel$+" - Familiendatei")
    WritePreferenceString("benutzer",userprg$)
    WritePreferenceLong("personenzahl",0)
    ClosePreferences()
    Schreibschutz(dat$,1)
    datneu$=dat$
  Else
    tit$="Dateifehler"
    txt$="Die Familiendatei "+da$+" konnte nicht angelegt werden.    "
    MessageRequester(tit$,txt$,#MB_ICONSTOP)
  EndIf
EndProcedure ; DateiAnlegen
;
Procedure DateiOeffnen(typ)
  If typ=1
    tit$="Familiendatei ffnen"
    Repeat
      dateineu$=OpenFileRequester(tit$,fam$,"Familiendateien|*.fam",0)
      If dateineu$=""
        ProcedureReturn
      ElseIf GetExtensionPart(dateineu$)<>"fam"
        txt$="Eine Familiendatei muss die Dateiendung fam haben.    "
        MessageRequester(tit$,txt$,#MB_ICONSTOP)
      ElseIf dateineu$=datei$
        InfoPerson()
        If Datentest()=1
          txt$="Die Datei "+GetFilePart(datei$)+" ist bereits geffnet.    "
          txt$+Chr(13)
          txt$+"Die aktuellen Daten wurden verndert, aber noch nicht gespeichert.    "
          txt$+Chr(13)
          txt$+"Wird die Datei nochmals geffnet, werden diese nderungen verworfen.    "
          txt$+Chr(13)+Chr(13)
          txt$+"Wollen Sie fortfahren?    "
          res=MessageRequester(tit$,txt$,#PB_MessageRequester_YesNo|#MB_ICONQUESTION|#MB_DEFBUTTON2)
          If res=#PB_MessageRequester_No
            ProcedureReturn
          EndIf
        EndIf
        quit=2
      ElseIf FileSize(dateineu$)<0
        txt$="Eine Familiendatei "+GetFilePart(dateineu$)+" existiert nicht.    "
        MessageRequester(tit$,txt$,#MB_ICONSTOP)
      ElseIf FindString(dateineu$,version$,1)=0
        txt$="Die Familiendatei "+GetFilePart(dateineu$)+" befindet sich nicht im aktuellen Anwendungsdatenverzeichnis.    "
        MessageRequester(tit$,txt$,#MB_ICONSTOP)
      Else
        quit=1
      EndIf
    Until quit>0
  Else
    dateineu$=datei$
  EndIf
  If quit<2
    DateiSchliessen(0)
  EndIf
  If OpenPreferences(dateineu$)
    datei$=dateineu$
    userdat$=ReadPreferenceString("benutzer","")
    If userdat$=""
       userdat$="?"
    EndIf
    If userdat$<>userprg$
      txt$+"Die Datei "+GetFilePart(datei$)+" wurde zuletzt von "
      txt$+Chr(13)
      txt$+"einem anderen Benutzer ("+userdat$+") bearbeitet.    "
      MessageRequester(tit$,txt$,#MB_ICONINFORMATION)
    EndIf
    perzahl=ReadPreferenceLong("personenzahl",100000)
    perzahlstart=perzahl
    NeuDim()
    For k=1 To perzahl
      daten$(k)=ReadPreferenceString("p"+Str(k),"")
      datenstart$(k)=daten$(k)
      DatenInStruktur(k)
    Next
    ClosePreferences()
    ConfigSpeichern(0)
  Else
    txt$="Die Familiendatei "+GetFilePart(dateineu$)+" konnte nicht geffnet werden.    "
    MessageRequester(programmtitel$,txt$,#MB_ICONSTOP)
    ProcedureReturn
  EndIf
  Sortierung(0)
  Liste()
  Initialisierung()
  SetGadgetText(1,"Personenliste "+GetFileName(datei$))
EndProcedure ; DateiOeffnen
;
Procedure DateiSchliessen(typ)
  Select modus
    Case 2
      For k=1 To perzahl
        StrukturInDaten(k)
      Next k
    Case 3
      StammdatenBearb()
    Case 4
      NeuePersonBearb()
  EndSelect
  DateiSpeichern(typ)
EndProcedure ; DateiSchliessen
; 
Procedure DatenInStruktur(k)
  txt$=daten$(k)
  n=FindString(txt$,"#n*",1)
  m=FindString(txt$,"#v*",1)
  Person(k)\nam=Mid(txt$,n+3,m-n-3)
  n=FindString(txt$,"#v*",1)
  m=FindString(txt$,"#x*",1)
  Person(k)\vor=Mid(txt$,n+3,m-n-3)
  n=FindString(txt$,"#x*",1)
  m=FindString(txt$,"#g*",1)
  Person(k)\gen=Mid(txt$,n+3,m-n-3)
  n=FindString(txt$,"#g*",1)
  m=FindString(txt$,"#s*",1)
  Person(k)\geb=Mid(txt$,n+3,m-n-3)
  n=FindString(txt$,"#s*",1)
  m=FindString(txt$,"#p*",1)
  Person(k)\ste=Mid(txt$,n+3,m-n-3)
  n=FindString(txt$,"#p*",1)
  m=FindString(txt$,"#m*",1)
  Person(k)\vat[0]=Val(Mid(txt$,n+3,m-n-4))
  Person(k)\vat[1]=Val(Mid(txt$,m-1,1))
  n=FindString(txt$,"#m*",1)
  m=FindString(txt$,"+",1)
  Person(k)\mut[0]=Val(Mid(txt$,n+3,m-n-4))
  Person(k)\mut[1]=Val(Mid(txt$,m-1,1))
  ;
  For i=0 To 189
    Person(k)\fam[i]=0
  Next i
  For i=10 To 189
    n=FindString(txt$,"#"+Str(i)+"*",1)
    m=FindString(txt$,"#",n+1)
    If i<100
      lg=4
    Else
      lg=5
    EndIf
    If n>0
      Person(k)\fam[i]=Val(Mid(txt$,n+lg,m-n-lg))
      ki+1
    EndIf
    Select i 
      Case 29
        Person(k)\fam[1]=Max(ki-1,0)
        ki=0
      Case 49
        Person(k)\fam[2]=Max(ki-1,0)
        ki=0
      Case 69
        Person(k)\fam[3]=Max(ki-1,0)
        ki=0
      Case 89
        Person(k)\fam[4]=Max(ki-1,0)
        ki=0
      Case 109
        Person(k)\fam[5]=Max(ki-1,0)
        ki=0
      Case 129
        Person(k)\fam[6]=Max(ki-1,0)
        ki=0
      Case 149
        Person(k)\fam[7]=Max(ki-1,0)
        ki=0
      Case 169
        Person(k)\fam[8]=Max(ki-1,0)
        ki=0
      Case 189
        Person(k)\fam[9]=Max(ki-1,0)
    EndSelect
  Next i
  ;
  n=FindString(txt$,"#***",1)
  Person(k)\inf=Mid(txt$,n+10,#info)
  ;
  For i=10 To 170 Step 20
    If Person(k)\fam[i]
      Person(k)\fam[0]+1
    EndIf
  Next i
EndProcedure ; DatenInStruktur
;
Procedure StrukturInDaten(k)
  dat$="#n*"+Person(k)\nam
  dat$+"#v*"+Person(k)\vor
  dat$+"#x*"+Person(k)\gen
  dat$+"#g*"+Person(k)\geb
  dat$+"#s*"+Person(k)\ste
  dat$+"#p*"+Str(Person(k)\vat[0])+Str(Person(k)\vat[1])
  dat$+"#m*"+Str(Person(k)\mut[0])+Str(Person(k)\mut[1])
  dat$+"+"
  For i=10 To 189
    If Person(k)\fam[i]>0
      dat$+"#"+Str(i)+"*"+Str(Person(k)\fam[i])
    EndIf
  Next i
  dat$+LSet("#***"+Str(k),10,"-")
  dat$+Person(k)\inf
  daten$(k)=dat$
EndProcedure ; StrukturInDaten
;
Procedure DateiSpeichern(typ)
  If instanz>1
    ProcedureReturn
  EndIf
  InfoPerson()
  da$=GetFilePart(datei$)
  tit$="Familiendatei speichern"
  ;
  If typ=1
    If Datentest()=1
      tit$+" - Programmende"
      txt$="Die aktuellen Daten wurden verndert.    "
      txt$+Chr(13)+Chr(13)
      txt$+"Sollen sie vor dem Programmende in der    "
      txt$+Chr(13)
      txt$+"Datei "+da$+" gespeichert werden?    "
      res=MessageRequester(tit$,txt$,#PB_MessageRequester_YesNoCancel|#MB_ICONQUESTION|#MB_SETFOREGROUND|#MB_DEFBUTTON3)
      If res=#PB_MessageRequester_Cancel
        progquit=0
        ProcedureReturn
      ElseIf res=#PB_MessageRequester_No
        ProcedureReturn
      EndIf
    Else
      ProcedureReturn 
    EndIf
  Else
    If Datentest()=1
      txt$="Die aktuellen Daten wurden verndert.    "
      txt$+Chr(13)+Chr(13)
      txt$+"Sollen sie in der Datei    "
    Else
      txt$="Sollen die aktuellen Daten in der Datei    "
    EndIf  
    txt$+Chr(13)+da$
    txt$+" gespeichert werden?    "
    res=MessageRequester(tit$,txt$,#PB_MessageRequester_YesNo|#MB_ICONQUESTION|#MB_SETFOREGROUND|#MB_DEFBUTTON2)
    If res=#PB_MessageRequester_No
      ProcedureReturn
    EndIf
  EndIf
  ;
  bak$=RemoveString(datei$,".fam",1)+FormatDate("%yy%mm%dd%hh%ii%ss",Date())+".bak"
  RenameFile(datei$,bak$)
  ;
  If CreatePreferences(datei$)
    PreferenceComment(programmtitel$+" - Familiendatei")
    WritePreferenceString("benutzer",userprg$)
    WritePreferenceLong("personenzahl",perzahl)
    For k=1 To perzahl
      StrukturInDaten(k)
      WritePreferenceString("p"+Str(k),daten$(k))
    Next k
    ClosePreferences()
    Schreibschutz(datei$,1)
    perzahlstart=perzahl
    For k=1 To perzahl
      datenstart$(k)=daten$(k)
    Next k
  Else
    tit$="Dateifehler"
    txt$="Die Datei "
    txt$+GetFilePart(datei$)
    txt$+" konnte nicht geschrieben werden.    "
    MessageRequester(tit$,txt$,#MB_ICONSTOP)
  EndIf
EndProcedure ; DateiSpeichern
;
Procedure DateiUebernehmen()
  DateiSpeichern(0)
  tit$="Familiendatei bernehmen"
  famalt$=appdatalt$+"*.fam"
  Repeat
    dateineu$=OpenFileRequester(tit$,famalt$,"Familiendateien|*.fam",0)
    If dateineu$=""
      ProcedureReturn
    ElseIf GetExtensionPart(dateineu$)<>"fam"
      txt$="Eine Familiendatei muss die Dateiendung fam haben.    "
      MessageRequester(tit$,txt$,#MB_ICONSTOP)
    ElseIf FileSize(dateineu$)<0
      txt$="Eine Familiendatei "+GetFilePart(dateineu$)+" existiert nicht.    "
      MessageRequester(tit$,txt$,#MB_ICONSTOP)
    ElseIf FindString(dateineu$,version$,1)
      txt$="Die Familiendatei  "+GetFilePart(dateineu$)+" befindet sich bereits im aktuellen Anwendungsdatenverzeichnis.    "
      MessageRequester(tit$,txt$,#MB_ICONSTOP)
    Else
      quit=1
    EndIf
  Until quit=1
  tst$=appdat$+GetFilePart(dateineu$)
  If FileSize(tst$)=-1
    CopyFile(dateineu$,tst$)
    Schreibschutz(tst$,1)
  Else
    bak$=RemoveString(tst$,".fam",1)+FormatDate("%yy%mm%dd%hh%ii%ss",Date())+".bak"
    txt$+"Im aktuellen Anwendungsdatenverzeichnis befindet sich    "
    txt$+Chr(13)
    txt$+"bereits eine Familiendatei "+GetFilePart(dateineu$)+".    "
    txt$+Chr(13)+Chr(13)
    txt$+"Wenn Sie die ausgewhlte Datei bernehmen, wird die aktuelle    "
    txt$+Chr(13)
    txt$+"Datei "+GetFilePart(dateineu$)+" in "+GetFilePart(bak$)+" umbenannt.    "
    txt$+Chr(13)+Chr(13)
    txt$+"Wollen Sie fortfahren?    "
    res=MessageRequester(tit$,txt$,#PB_MessageRequester_YesNo|#MB_ICONQUESTION|#MB_DEFBUTTON2)
    If res=#PB_MessageRequester_No
      ProcedureReturn
    EndIf
    Schreibschutz(tst$,0)
    If RenameFile(tst$,bak$)=0
      txt$="Das Umbenennen der aktuellen Datei ist fehlgeschlagen.    "
      txt$+Chr(13)
      txt$+"Die bernahme der Familiendatei wird abgebrochen.    "
      MessageRequester(tit$,txt$,#MB_ICONSTOP)
      Schreibschutz(tst$,1)
      ProcedureReturn
    EndIf
    Schreibschutz(bak$,1)
    CopyFile(dateineu$,tst$)
    Schreibschutz(tst$,1)
  EndIf
  If GetFilePart(datei$)=GetFilePart(dateineu$)
    DateiOeffnen(0)
  EndIf
EndProcedure ; DateiUebernehmen
;
Procedure Liste()
  ReDim li$(perzahl)
  ;
  For k=1 To perzahl
    li$(k)=daten$(k)
    li$(k)=ReplaceString(li$(k),Chr(32),Chr(255))
    li$(k)=ReplaceString(li$(k),Chr(45),Chr(254))
    li$(k)=ReplaceString(li$(k),Chr(138),"S")
    li$(k)=ReplaceString(li$(k),Chr(140),"OE")
    li$(k)=ReplaceString(li$(k),Chr(142),"Z")
    li$(k)=ReplaceString(li$(k),Chr(154),"s")
    li$(k)=ReplaceString(li$(k),Chr(156),"oe")
    li$(k)=ReplaceString(li$(k),Chr(158),"z")
    li$(k)=ReplaceString(li$(k),Chr(159),"Y")
    li$(k)=ReplaceString(li$(k),Chr(192),"A")
    li$(k)=ReplaceString(li$(k),Chr(193),"A")
    li$(k)=ReplaceString(li$(k),Chr(194),"A")
    li$(k)=ReplaceString(li$(k),Chr(195),"A")
    li$(k)=ReplaceString(li$(k),Chr(196),"A")
    li$(k)=ReplaceString(li$(k),Chr(197),"A")
    li$(k)=ReplaceString(li$(k),Chr(198),"AE")
    li$(k)=ReplaceString(li$(k),Chr(199),"C")
    li$(k)=ReplaceString(li$(k),Chr(200),"E")
    li$(k)=ReplaceString(li$(k),Chr(201),"E")
    li$(k)=ReplaceString(li$(k),Chr(202),"E")
    li$(k)=ReplaceString(li$(k),Chr(203),"E")
    li$(k)=ReplaceString(li$(k),Chr(204),"I")
    li$(k)=ReplaceString(li$(k),Chr(205),"I")
    li$(k)=ReplaceString(li$(k),Chr(206),"I")
    li$(k)=ReplaceString(li$(k),Chr(207),"I")
    li$(k)=ReplaceString(li$(k),Chr(208),"T")
    li$(k)=ReplaceString(li$(k),Chr(209),"N")
    li$(k)=ReplaceString(li$(k),Chr(210),"O")
    li$(k)=ReplaceString(li$(k),Chr(211),"O")
    li$(k)=ReplaceString(li$(k),Chr(212),"O")
    li$(k)=ReplaceString(li$(k),Chr(213),"O")
    li$(k)=ReplaceString(li$(k),Chr(214),"O")
    li$(k)=ReplaceString(li$(k),Chr(216),"O")
    li$(k)=ReplaceString(li$(k),Chr(217),"U")
    li$(k)=ReplaceString(li$(k),Chr(218),"U")
    li$(k)=ReplaceString(li$(k),Chr(219),"U")
    li$(k)=ReplaceString(li$(k),Chr(220),"U")
    li$(k)=ReplaceString(li$(k),Chr(221),"Y")
    li$(k)=ReplaceString(li$(k),Chr(222),"T")
    li$(k)=ReplaceString(li$(k),Chr(223),"ss")
    li$(k)=ReplaceString(li$(k),Chr(224),"a")
    li$(k)=ReplaceString(li$(k),Chr(225),"a")
    li$(k)=ReplaceString(li$(k),Chr(226),"a")
    li$(k)=ReplaceString(li$(k),Chr(227),"a")
    li$(k)=ReplaceString(li$(k),Chr(228),"a")
    li$(k)=ReplaceString(li$(k),Chr(229),"a")
    li$(k)=ReplaceString(li$(k),Chr(230),"ae")
    li$(k)=ReplaceString(li$(k),Chr(231),"c")
    li$(k)=ReplaceString(li$(k),Chr(232),"e")
    li$(k)=ReplaceString(li$(k),Chr(233),"e")
    li$(k)=ReplaceString(li$(k),Chr(234),"e")
    li$(k)=ReplaceString(li$(k),Chr(235),"e")
    li$(k)=ReplaceString(li$(k),Chr(236),"i")
    li$(k)=ReplaceString(li$(k),Chr(237),"i")
    li$(k)=ReplaceString(li$(k),Chr(238),"i")
    li$(k)=ReplaceString(li$(k),Chr(239),"i")
    li$(k)=ReplaceString(li$(k),Chr(240),"t")
    li$(k)=ReplaceString(li$(k),Chr(241),"n")
    li$(k)=ReplaceString(li$(k),Chr(242),"o")
    li$(k)=ReplaceString(li$(k),Chr(243),"o")
    li$(k)=ReplaceString(li$(k),Chr(244),"o")
    li$(k)=ReplaceString(li$(k),Chr(245),"o")
    li$(k)=ReplaceString(li$(k),Chr(246),"o")
    li$(k)=ReplaceString(li$(k),Chr(248),"o")
    li$(k)=ReplaceString(li$(k),Chr(249),"u")
    li$(k)=ReplaceString(li$(k),Chr(250),"u")
    li$(k)=ReplaceString(li$(k),Chr(251),"u")
    li$(k)=ReplaceString(li$(k),Chr(252),"u")
    li$(k)=ReplaceString(li$(k),Chr(253),"y")
    li$(k)=ReplaceString(li$(k),Chr(254),"t")
    li$(k)=ReplaceString(li$(k),Chr(255),"y")
    ;
    li$(k)=ReplaceString(li$(k),"NN(","ZZZ(")
    li$(k)=ReplaceString(li$(k),"?","ZZZ")
    ;
    Select sort
      Case 0
        li$(k)="#n*"+Parse(li$(k),1) 
      Case 2
        If Person(k)\vor="?"
          vr$="ZZZ"
        Else
          vr$=Person(k)\vor
        EndIf
        li$(k)="#n*"+Parse(li$(k),1)
        li$(k)=vr$+Space(50)+li$(k)
    EndSelect
  Next k
  ;
  SortArray(li$(),#PB_Sort_NoCase)
  ClearGadgetItems(2)
  For k=1 To perzahl
    n=FindString(li$(k),"#***",1)
    idx(k)=Val(Mid(li$(k),n+4,Len(Str(perzahl)))) ; = Nr. der Person in Zeile k der Liste
    inv(idx(k))=k
    txt$=Person(idx(k))\nam+",  "+Person(idx(k))\vor
    If Left(txt$,5)<>"ZZZZZ"
      AddGadgetItem(2,-1,txt$)
    EndIf
  Next k
EndProcedure ; Liste
;
Procedure NeuDim()
  ReDim Person.per(perzahl)
  ReDim daten$(perzahl)
  ReDim datenstart$(perzahl)
  ReDim idx(perzahl)
  ReDim inv(perzahl)
EndProcedure ; NeuDim
;
Procedure Initialisierung()
  SteuerungModus(0)
  pgad=0
  For i=1 To 189
    prs(i)=0
  Next i
  If perzahl>0
    txt$="Whlen Sie eine Person aus der Personenliste aus !"
  Else
    If instanz>1
      txt$="ffnen Sie eine Familiendatei !"
    Else
      txt$="ffnen Sie eine Familiendatei oder fgen Sie eine Person hinzu !"
    EndIf
  EndIf
  Hilfe(0,txt$)
EndProcedure ; Initialisierung
;
Procedure Schreibschutz(d$,typ)
  If FileSize(d$)<0
    ProcedureReturn
  EndIf
  If typ=0
    SetFileAttributes(d$,#PB_FileSystem_Normal)
  Else
    SetFileAttributes(d$,#PB_FileSystem_ReadOnly)
  EndIf
EndProcedure ; Schreibschutz
;
Procedure Benutzername()
  tit$="Benutzernamen ndern"
  txt1$="Benutzername:"
  da$=InputRequester(tit$,txt1$,userprg$)
  da$=Trim(da$)
  da$=Parse(da$)
  If da$=#fehler
    da$=""
  EndIf  
  If da$=""
    ProcedureReturn
  Else
    userprg$=da$
    ConfigSpeichern(0)
  EndIf
EndProcedure ; Benutzername
;
Procedure Instanzreset()
  tit$="Beenden mit Instanzreset"
  txt$="Werden durch eine Fehlfunktion nur noch Anzeigefenster    "
  txt$+Chr(13)
  txt$+"ohne Bearbeitungsfunktionen geffnet, kann durch diesen    "   
  txt$+Chr(13)
  txt$+"Reset dieser Fehler behoben werden. Dabei wird dieses    "
  txt$+Chr(13)
  txt$+"Programmfenster geschlossen.    "
  txt$+Chr(13)+Chr(13)
  txt$+"Danach mssen alle anderen eventuell noch geffneten    "
  txt$+Chr(13)
  txt$+"Programmfenster sofort geschlossen werden.    "
  txt$+Chr(13)+Chr(13)
  txt$+"Soll der Reset durchgefhrt werden?    "
  res=MessageRequester(tit$,txt$,#PB_MessageRequester_YesNo|#MB_ICONQUESTION|#MB_SETFOREGROUND|#MB_DEFBUTTON2)
  If res=#PB_MessageRequester_Yes
    instanz=999999999
    progquit=1
    Programmende()
  EndIf
EndProcedure ; Instanzreset
;
Procedure Programmende()
  DateiSchliessen(1) ; setzt progquit=0 bei Abbrechen von DateiSpeichern()
  If progquit=1
    If OpenPreferences(ein$)
      PreferenceGroup("Instanz")
        If instanz<>999999999
          instanz=ReadPreferenceLong("Instanz",0)
        EndIf
      ClosePreferences()
      If instanz=999999999
        instanz=0
      ElseIf instanz>0
        instanz-1
      EndIf
    Else
      instanz=0 
    EndIf
    ConfigSpeichern(2)
    End
  EndIf
EndProcedure ; Programmende
; 
;- FENSTER
Procedure Fensterauf()
  tit$="Fehler beim Programmstart"
  txt1$="Das bentigte Programmfenster konnte nicht geffnet werden.    "
  txt2$="Das bentigte Programmfenster konnte nicht korrekt dargestellt werden.    "
  ;
  WinID=OpenWindow(0,0,0,#spalten,#zeilen,fenstertitel$,#PB_Window_MinimizeGadget|#PB_Window_ScreenCentered|#PB_Window_Invisible)
  If WinID=0
    MessageRequester(programmtitel$+": "+tit$,txt1$+exit$,#MB_ICONSTOP)
    progquit=1
    Programmende()
  EndIf
  If CreateToolBar(0,WinID)=0
    MessageRequester(programmtitel$+": "+tit$,txt2$+exit$,#MB_ICONSTOP)
    progquit=1
    Programmende()
  EndIf
  If CreateStatusBar(0,WinID)
    AddStatusBarField(#PB_Ignore)
  Else
    MessageRequester(programmtitel$+": "+tit$,txt2$+exit$,#MB_ICONSTOP)
    progquit=1
    Programmende()
  EndIf
  If instanz>1
    ResizeWindow(0,WindowX(0)-75,WindowY(0)-75,#PB_Ignore,#PB_Ignore)
  EndIf
  StickyWindow(0,0)
  AddKeyboardShortcut(0,#PB_Shortcut_F1,41)
EndProcedure ; Fensterauf
;
;- STEUERUNG
Procedure InitMenuGadget()
  If CreateMenu(0,WinID)
    MenuTitle("Datei")
      MenuItem(11,"Familiendatei anlegen...")
      MenuItem(12,"Familiendatei ffnen...")
      MenuItem(13,"Familiendatei speichern")
      MenuItem(14,"Familiendatei bernehmen...")
      MenuItem(17,"Pfade anzeigen")
      If instanz>1
        MenuBar()
        MenuItem(18,"Beenden mit Instanzreset")
      EndIf  
      MenuBar()
      MenuItem(19,"Beenden")
    MenuTitle("Benutzer")
      MenuItem(21,"Benutzernamen ndern...")
    MenuTitle("Suchen")
      MenuItem(31,"Person suchen...") 
      MenuItem(32,"Familiennamen suchen...")
      MenuItem(33,"Vornamen suchen...")
    MenuTitle("Hilfe") 
      MenuItem(41,"Handbuch ffnen..."+Chr(9)+"F1")
      MenuItem(49,"Info ber "+programmtitel$)
  Else
    txt$="Das Men konnte nicht initialisiert werden.    "+exit$
    MessageRequester(programmtitel$,txt$,#MB_ICONSTOP)
    progquit=1
    Programmende()
  EndIf
  ;
  fnt=LoadFont(1,"Arial",9,#PB_Font_Bold|#PB_Font_HighQuality)
  If fnt<>0
    SetGadgetFont(#PB_Default,fnt)
  Else
    SetGadgetFont(#PB_Default,#PB_Default)
  EndIf
  ; Personenliste:
  Frame3DGadget(1,10,10,200,444,"Personenliste "+GetFileName(datei$))
  ListViewGadget(2,20,30,180,334);348
  Frame3DGadget(295,20,368,180,75,"Sortieren nach")
  OptionGadget(296,30,384,160,20,"  erstem Grobuchstaben")
  OptionGadget(297,30,401,160,20,"  erstem Buchstaben")
  OptionGadget(298,30,418,160,20,"  Vornamen")
  SetGadgetState(296,1)
  ; Verbindungen etc.:
  Frame3DGadget(3,220,10,750,656,"")
  ContainerGadget(4,240,105,240,65,#PB_Container_Double)
  SetGadgetColor(4,#PB_Gadget_BackColor,RGB(255,255,220))
  ButtonGadget(5,85,12,140,40,"",#PB_Button_MultiLine) ; Person
  TextGadget(6,10,12,66,18,"",#PB_Text_Center|#PB_Text_Border) ; *
  SetGadgetColor(6,#PB_Gadget_BackColor,RGB(255,255,255))
  TextGadget(7,10,34,66,18,"",#PB_Text_Center|#PB_Text_Border) ; +
  SetGadgetColor(7,#PB_Gadget_BackColor,RGB(255,255,255))
  CloseGadgetList() ; ContainerGadget-Liste 4 schlieen
  ; Eltern-, Partner- und Kinder-Gadgets 8-189 werden dynamisch erzeugt
  ; Modus:
  Frame3DGadget(200,10,466,200,200,"Modus")
  ButtonGadget(201,20,486,180,30,"Verbindungen anzeigen")
  ButtonGadget(202,20,521,180,30,"Verbindungen bearbeiten")
  ButtonGadget(203,20,556,180,30,"Stammdaten bearbeiten")
  ButtonGadget(204,20,591,180,30,"Person hinzufgen")
  ButtonGadget(205,20,626,180,30,"Person entfernen")
  ; Stammdaten, neue Person:
  ContainerGadget(250,395,255,400,175,#PB_Container_Raised)
  StringGadget(251,110,17,265,20,"") ; Familienname
  StringGadget(252,110,47,265,20,"") ; Vorname
  StringGadget(253,110,77,265,20,"") ; *
  StringGadget(254,110,107,265,20,"") ; + 
  OptionGadget(255,155,138,80,20,"mnnlich")
  OptionGadget(256,265,138,80,20,"weiblich")
  TextGadget(261,20,20,80,20,"Familienname")
  TextGadget(262,20,50,80,20,"Vorname")
  TextGadget(263,20,80,80,20,"Geburtsdatum")
  TextGadget(264,20,110,80,20,"Todesdatum")
  TextGadget(265,20,140,70,20,"Geschlecht")
  CloseGadgetList() ; ContainerGadget-Liste 250 schlieen
  ; Schalter fr Verbindungen bearbeiten:
  ContainerGadget(271,240,195,240,65,#PB_Container_Double)
  OptionGadget(272,40,10,160,20,"   Verbindung hinzufgen")
  OptionGadget(273,40,35,160,20,"   Verbindung entfernen")
  CloseGadgetList() ; ContainerGadget-Liste 271 schlieen
  ; Info:
  Frame3DGadget(280,240,188,240,465,"")
  EditorGadget(281,250,206,220,436)
  SetGadgetColor(281,#PB_Gadget_BackColor,RGB(255,255,220))
  ; Vorfahrengadgets werden dynamisch erzeugt
EndProcedure ; InitMenuGadget
;
Procedure SteuerungModus(mod)
  modus=mod
  Select modus
    Case 0
      For i=11 To 13
        DisableMenuItem(0,i,0)
      Next i
      If appdatalt$=""
        DisableMenuItem(0,14,1)
      Else
        DisableMenuItem(0,14,0)
      EndIf
      DisableGadget(2,0)
      SetGadgetText(3,"Verbindungen anzeigen")
      For i=4 To 7
        HideGadget(i,1)
      Next i
      DynGadgetWeg()
      DisableGadget(201,1)
      DisableGadget(202,1)
      DisableGadget(203,1)
      DisableGadget(204,0)
      DisableGadget(205,1)
      HideGadget(250,1)
      HideGadget(271,1)
      HideGadget(280,1)
      HideGadget(281,1)
    Case 1
      For i=11 To 13
        DisableMenuItem(0,i,0)
      Next i
      If appdatalt$=""
        DisableMenuItem(0,14,1)
      Else
        DisableMenuItem(0,14,0)
      EndIf
      DisableGadget(2,0)
      SetGadgetText(3,"Verbindungen anzeigen")
      For i=4 To 7
        HideGadget(i,0)
      Next i
      DynGadgetWeg()
      DisableGadget(201,1)
      DisableGadget(202,0)
      DisableGadget(203,0)
      DisableGadget(204,0)
      DisableGadget(205,0)
      HideGadget(250,1)
      HideGadget(271,1)
      HideGadget(280,0)
      HideGadget(281,0)
    Case 2
      For i=11 To 14
        DisableMenuItem(0,i,1)
      Next i
      DisableGadget(2,0)
      SetGadgetText(3,"Verbindungen bearbeiten")
      For i=4 To 7
        HideGadget(i,0)
      Next i
      DisableGadget(201,0)
      DisableGadget(202,1)
      DisableGadget(203,1)
      DisableGadget(204,1)
      DisableGadget(205,1)
      HideGadget(250,1)
      weg=0
      HideGadget(271,0)
      SetGadgetState(272,1)
      SetGadgetState(273,0)
      HideGadget(280,0)
      HideGadget(281,0)
    Case 3
      For i=11 To 14
        DisableMenuItem(0,i,1)
      Next i
      DisableGadget(2,1)
      SetGadgetText(3,"Stammdaten bearbeiten")
      For i=4 To 7
        HideGadget(i,1)
      Next i
      DynGadgetWeg()
      DisableGadget(201,0)
      DisableGadget(202,1)
      DisableGadget(203,1)
      DisableGadget(204,1)
      DisableGadget(205,1)
      HideGadget(250,0)
      HideGadget(271,1)
      HideGadget(280,1)
      HideGadget(281,1)
    Case 4
      For i=11 To 14
        DisableMenuItem(0,i,1)
      Next i
      DisableGadget(2,1)
      SetGadgetText(3,"Person hinzufgen")
      For i=4 To 7
        HideGadget(i,1)
      Next i
      DynGadgetWeg()
      DisableGadget(201,0)
      DisableGadget(202,1)
      DisableGadget(203,1)
      DisableGadget(204,1)
      DisableGadget(205,1)
      HideGadget(250,0)
      HideGadget(271,1)
      HideGadget(280,1)
      HideGadget(281,1)
    Case 5
      For i=11 To 14
        DisableMenuItem(0,i,1)
      Next i
      DisableGadget(2,1)
      SetGadgetText(3,"Vorfahren anzeigen")
      For i=4 To 7
        HideGadget(i,1)
      Next i
      DynGadgetWeg()
      DisableGadget(201,0)
      DisableGadget(202,1)
      DisableGadget(203,1)
      DisableGadget(204,1)
      DisableGadget(205,1)
      HideGadget(250,1)
      HideGadget(271,1)
      HideGadget(280,1)
      HideGadget(281,1)
  EndSelect
  If instanz>1
    DisableMenuItem(0,11,1)
    DisableMenuItem(0,13,1)
    DisableMenuItem(0,14,1)
    DisableMenuItem(0,17,1)
    DisableMenuItem(0,21,1)
    DisableMenuItem(0,41,1)
    DisableMenuItem(0,49,1)
    DisableGadget(202,1)
    DisableGadget(203,1)
    DisableGadget(204,1)
    DisableGadget(205,1)
    DisableGadget(281,1)
  EndIf
EndProcedure ; SteuerungModus
;
Procedure AdoptGadget(typ)
  Select typ
    Case 1 ; Gadget Vater erzeugen
      CheckBoxGadget(276,264,82,100,20," Kind adoptiert")
      If Person(prs(5))\vat[1]=1
        SetGadgetState(276,1)
      Else
        SetGadgetState(276,0)
      EndIf
    Case 2 ; Gadget Mutter erzeugen
      CheckBoxGadget(277,442,82,100,20," Kind adoptiert")
      If Person(prs(5))\mut[1]=1
        SetGadgetState(277,1)
      Else
        SetGadgetState(277,0)
      EndIf
    Case 3 ; Gadget Vater abfragen
      If GetGadgetState(276)=1
        Person(prs(5))\vat[1]=1
      Else
        Person(prs(5))\vat[1]=0
      EndIf
    Case 4 ; Gadget Mutter abfragen
      If GetGadgetState(277)=1
        Person(prs(5))\mut[1]=1
      Else
        Person(prs(5))\mut[1]=0
      EndIf
  EndSelect
EndProcedure ; AdoptGadget
;
Procedure DynGadgetWeg()
  If IsGadget(8)
    FreeGadget(8)
  EndIf
  prs(8)=0
  If IsGadget(9)
    FreeGadget(9)
  EndIf
  prs(9)=0
  If IsGadget(190)
    FreeGadget(190) ; und damit 10...189, 191...199, 711...719, 721...729
  EndIf
  If IsGadget(276)
    FreeGadget(276)
  EndIf
  If IsGadget(277)
    FreeGadget(277)
  EndIf
  If IsGadget(300)
    FreeGadget(300) ; und damit 301...427, 501...563, 601...663, 1003, 1007, 1015, 1031, 1063, 1127
  EndIf
  If IsGadget(700)
    FreeGadget(700) ; und damit 701, 702
  EndIf
EndProcedure ; DynGadgetWeg
;
;- MODUS
Procedure VerbindungenAnzeigen(num)
  InfoPerson()
  SteuerungModus(1)
  For i=1 To 189
    prs(i)=0
  Next i
  If (Person(num)\fam[0]>0) Or (Person(num)\vat[0]>0)
    DisableGadget(205,1)
  Else
    DisableGadget(205,0)
  EndIf
  ; Familienname + Vorname:
  txt$=Person(num)\nam+Chr(13)+Person(num)\vor
  SetGadgetText(5,txt$)
  prs(5)=num
  ; *:
  If Person(num)\geb<>"0"
    SetGadgetText(6,Person(num)\geb)
  Else
    SetGadgetText(6,"")
  EndIf
  ; +:
  If Person(num)\ste<>"0"
    SetGadgetText(7,Person(num)\ste)
  Else
    SetGadgetText(7,"")
  EndIf
  SetGadgetText(280,Person(num)\vor+" "+Person(num)\nam)
  info$=Person(num)\inf
  ReplaceString(info$,Chr(35)+Chr(35),Chr(13)+Chr(10),#PB_String_InPlace)
  SetGadgetText(281,info$)
  ;
  ResizeGadget(280,#PB_Ignore,188,#PB_Ignore,465)
  ResizeGadget(281,#PB_Ignore,206,#PB_Ignore,436)
  ;
  DynGadgetWeg()
  p=Person(num)\vat[0]
  If p>0
    ButtonGadget(8,240,40,140,40,"",#PB_Button_MultiLine) ; Vater
    If Person(num)\vat[1]=1
      adv$="*"
    EndIf
    txt$=Person(p)\nam+adv$+Chr(13)+Person(p)\vor
    If Left(txt$,5)<>"ZZZZZ"
      SetGadgetText(8,txt$)
      DisableGadget(8,0)
    Else
      SetGadgetText(8,"Kein Partner")
      DisableGadget(8,1)
    EndIf
    prs(8)=p
    p=Person(num)\mut[0]
    ButtonGadget(9,420,40,140,40,"",#PB_Button_MultiLine) ; Mutter
    If Person(num)\mut[1]=1
      adm$="*"
    EndIf
    txt$=Person(p)\nam+adm$+Chr(13)+Person(p)\vor
    If Left(txt$,5)<>"ZZZZZ"
      SetGadgetText(9,txt$)
      DisableGadget(9,0)
    Else
      SetGadgetText(9,"Kein Partner")
      DisableGadget(9,1)
    EndIf
    prs(9)=p
  EndIf
  prt=Person(num)\fam[0]
  gp=Max(prt-3,0)
  If prt>0
    ScrollAreaGadget(190,482,105,485,548,485+160*gp,520,160,#PB_ScrollArea_BorderLess)
    For i=1 To prt
      ; Partner:
      ii=20*i-10
      ButtonGadget(ii,160*i-150,15,140,40,"",#PB_Button_MultiLine) ; relativ zu 190
      p=Person(num)\fam[ii]
      txt$=Person(p)\nam+Chr(13)+Person(p)\vor
      If Left(txt$,5)<>"ZZZZZ"
        SetGadgetText(ii,txt$)
        DisableGadget(ii,0)
      Else
        SetGadgetText(ii,"Kein Partner");
        DisableGadget(ii,1)
      EndIf
      HideGadget(ii,0)
      prs(ii)=p
      If i=1
        Frame3DGadget(711,0,35,10,1,"",#PB_Frame3D_Flat)
      Else
        Frame3DGadget(710+i,160*i-170,35,20,1,"",#PB_Frame3D_Flat)
      EndIf
      ; Kinder:
      kin(i)=Person(num)\fam[i]
      hscr(i)=10+kin(i)*52
      hges(i)=Min(hscr(i),426)+2
      If kin(i)>0
        If kin(i)>8
          bsub(i)=18
        Else
          bsub(i)=0
        EndIf
        Frame3DGadget(720+i,160*i-80,55,1,34,"",#PB_Frame3D_Flat)
        ScrollAreaGadget(190+i,i*160-150,90,140,hges(i),128-bsub(i),hscr(i),52,#PB_ScrollArea_Single)
        For k=1 To kin(i)
          adkv$=""
          adkm$=""
          ik=20*i-10+k      
          ButtonGadget(ik,10,11+(k-1)*52,118-bsub(i),40,"",#PB_Button_MultiLine)
          p=Person(num)\fam[ik]
          If p>0
            If Person(p)\vat[1]=1
              adkv$="*"
            EndIf
            If Person(p)\mut[1]=1
              adkm$="*"
            EndIf
            If Person(p)\mut[0]=prs(5)
              Swap adkv$,adkm$
            EndIf
            txt$=adkv$+Person(p)\nam+adkm$+Chr(13)+Person(p)\vor
            SetGadgetText(ik,txt$)
            prs(ik)=p
          EndIf
        Next k
        CloseGadgetList() ; ScrollAreaGadget-Liste 190+i schlieen
      EndIf
    Next i
    CloseGadgetList() ; ScrollAreaGadget-Liste 190 schlieen 
  EndIf
  ;
  SetGadgetState(2,inv(prs(5))-1)
  ;
  If Person(num)\vat[0]>0
    ContainerGadget(700,380,40,40,65)
    Frame3DGadget(701,0,20,40,1,"",#PB_Frame3D_Flat)  ; Vater ... Mutter
    Frame3DGadget(702,19,20,1,44,"",#PB_Frame3D_Flat) ; ... Person
    CloseGadgetList() ; ContainerGadget-Liste 700 schlieen
  EndIf
  ;
  txt$="Jede Person wird durch Anklicken zur Zentralperson.  "
  txt$+"Anklicken der Zentralperson zeigt deren Vorfahren an."
  Hilfe(0,txt$)
EndProcedure ; VerbindungenAnzeigen
;
Procedure VerbindungenBearbeiten()
  InfoPerson()
  SteuerungModus(2)
  num=prs(5)
  SetGadgetState(2,-1)
  pgad=0
  ; Familienname + Vorname:
  txt$=Person(num)\nam+Chr(13)+Person(num)\vor
  SetGadgetText(5,txt$)
  prs(5)=num
  ; *:
  If Person(num)\geb<>"0"
    SetGadgetText(6,Person(num)\geb)
  Else
    SetGadgetText(6,"")
  EndIf
  ; +:
  If Person(num)\ste<>"0"
    SetGadgetText(7,Person(num)\ste)
  Else
    SetGadgetText(7,"")
  EndIf
  ;
  ResizeGadget(280,#PB_Ignore,278,#PB_Ignore,375)
  ResizeGadget(281,#PB_Ignore,296,#PB_Ignore,346)
  ;
  DynGadgetWeg()
  ButtonGadget(8,240,40,140,40,"",#PB_Button_MultiLine) ; Vater
  ButtonGadget(9,420,40,140,40,"",#PB_Button_MultiLine) ; Mutter
  p=Person(num)\vat[0]
  If p>0
    txt$=Person(p)\nam+Chr(13)+Person(p)\vor
    If Left(txt$,5)<>"ZZZZZ"
      SetGadgetText(8,txt$)
      DisableGadget(8,0)
      AdoptGadget(1)
    Else
      SetGadgetText(8,"Kein Partner")
      DisableGadget(8,1)
    EndIf
    prs(8)=p
    p=Person(num)\mut[0]
    txt$=Person(p)\nam+Chr(13)+Person(p)\vor
    If Left(txt$,5)<>"ZZZZZ"
      SetGadgetText(9,txt$)
      DisableGadget(9,0)
      AdoptGadget(2)
    Else
      SetGadgetText(9,"Kein Partner")
      DisableGadget(9,1)
    EndIf
    prs(9)=p
  EndIf
  ;
  prt=Person(num)\fam[0]
  If prt<9
    prt+1
  EndIf
  gp=Max(prt-3,0)
  ScrollAreaGadget(190,482,105,485,548,485+160*gp,520,160,#PB_ScrollArea_BorderLess)
  For i=1 To prt
    ; Partner:
    ii=20*i-10
    ButtonGadget(ii,160*i-150,15,140,40,"",#PB_Button_MultiLine) ; relativ zu 190
    p=Person(num)\fam[ii]
    txt$=Person(p)\nam+Chr(13)+Person(p)\vor
    If Left(txt$,5)<>"ZZZZZ"
      SetGadgetText(ii,txt$)
      DisableGadget(ii,0)
    Else
      SetGadgetText(ii,"Kein Partner")
      DisableGadget(ii,1)
    EndIf
    HideGadget(ii,0)
    prs(ii)=p
    If i=1
      Frame3DGadget(711,0,35,10,1,"",#PB_Frame3D_Flat)
    Else
      Frame3DGadget(710+i,160*i-170,35,20,1,"",#PB_Frame3D_Flat)
    EndIf
    ; Kinder:
    kin(i)=Person(num)\fam[i]
    If (kin(i)<19) And (i<prt)
      kin(i)+1
    EndIf
    hscr(i)=10+kin(i)*52
    hges(i)=Min(hscr(i),426)+2
    If kin(i)>0
      If kin(i)>8
        bsub(i)=18
      Else
        bsub(i)=0
      EndIf
      Frame3DGadget(720+i,160*i-80,55,1,34,"",#PB_Frame3D_Flat)
      ScrollAreaGadget(190+i,i*160-150,90,140,hges(i),128-bsub(i),hscr(i),52,#PB_ScrollArea_Single)
      For k=1 To kin(i)
        adkv$=""
        adkm$=""
        ik=20*i-10+k
        ButtonGadget(ik,10,11+(k-1)*52,118-bsub(i),40,"",#PB_Button_MultiLine)
        p=Person(num)\fam[ik]
        If p>0
          If Person(p)\vat[1]=1
            adkv$="*"
          EndIf
          If Person(p)\mut[1]=1
            adkm$="*"
          EndIf
          If Person(p)\mut[0]=prs(5)
            Swap adkv$,adkm$
          EndIf
          txt$=adkv$+Person(p)\nam+adkm$+Chr(13)+Person(p)\vor
          SetGadgetText(ik,txt$)
          prs(ik)=p
        EndIf
      Next k
      CloseGadgetList() ; ScrollAreaGadget-Liste 190+i schlieen
    EndIf
  Next i
  CloseGadgetList() ; ScrollAreaGadget-Liste 190 schlieen
  ;
  ContainerGadget(700,380,40,40,65)
  Frame3DGadget(701,0,20,40,1,"",#PB_Frame3D_Flat)  ; Vater ... Mutter
  Frame3DGadget(702,19,20,1,44,"",#PB_Frame3D_Flat) ; ... Person
  CloseGadgetList() ; ContainerGadget-Liste 700 schlieen
  ;
  HinWeg(0)
EndProcedure ; VerbindungenBearbeiten
;
Procedure Stammdaten()
  InfoPerson()
  SteuerungModus(3)
  num=prs(5)
  For i=1 To 9
    numkin+Person(num)\fam[i]
  Next i
  If numkin>0
    dis=1
  EndIf
  ;
  For k=251 To 254
    SetGadgetText(k,"")
  Next k
  SetGadgetText(251,Person(num)\nam)
  SetGadgetText(252,Person(num)\vor)
  If Person(num)\geb<>"0"
    SetGadgetText(253,Person(num)\geb)
  EndIf
  If person(num)\ste<>"0"
    SetGadgetText(254,Person(num)\ste)
  EndIf
  If Person(num)\gen="m"
    SetGadgetState(255,1)
    SetGadgetState(256,0)
    DisableGadget(255,dis)
    DisableGadget(256,dis)
  Else
    SetGadgetState(255,0)
    SetGadgetState(256,1)
    DisableGadget(255,dis)
    DisableGadget(256,dis)
  EndIf
  stamm$=Prueftext()
  txt$="bernehmen: Verbindungen anzeigen/Programmende"
  Hilfe(0,txt$)
EndProcedure ; Stammdaten
;
Procedure NeuePerson()
  InfoPerson()
  SteuerungModus(4)
  For k=251 To 254
    SetGadgetText(k,"")
  Next k
  SetGadgetState(255,1)
  SetGadgetState(256,0)
  DisableGadget(255,0)
  DisableGadget(256,0)
  For k=261 To 265
    HideGadget(k,0)
  Next k
  txt$="bernehmen: Verbindungen anzeigen/Programmende"
  Hilfe(0,txt$)
EndProcedure ; NeuePerson
;
Procedure Vorfahren()
  vor(1)=prs(5) 
  For p=1 To 127
    vor(2*p)=Person(vor(p))\vat[0]
    vor(2*p+1)=Person(vor(p))\mut[0]
  Next p
  For p=255 To 1 Step -1
    If vor(p)
      Break
    EndIf
  Next p
  Select p
    Case 1
      ProcedureReturn
    Case 2 To 3
      generation=1
      gadnum=3
    Case 4 To 7
      generation=2
      gadnum=7
    Case 8 To 15
      generation=3
      gadnum=15
    Case 16 To 31
      generation=4
      gadnum=31
    Case 32 To 63
      generation=5
      gadnum=63
    Case 64 To 127
      generation=6
      gadnum=127
    Default
      generation=7
      gadnum=127
  EndSelect
  ;
  SteuerungModus(5)
  Select generation
    Case 1
      ScrollAreaGadget(300,230,30,730,625,720,592,4,#PB_ScrollArea_Single)
      HideGadget(300,1)
      ButtonGadget(301,290,510,140,40,"",#PB_Button_MultiLine)
      Frame3DGadget(501,355,451,10,1,"",#PB_Frame3D_Flat)
      Frame3DGadget(601,360,451,1,59,"",#PB_Frame3D_Flat)
      For i=0 To 1 ; Gadget 302 - 303
        ButtonGadget(302+i,215+i*150,431,140,40,"",#PB_Button_MultiLine)
      Next i
      CloseGadgetList() ; ScrollAreaGadget 300 schlieen
    Case 2
      ScrollAreaGadget(300,230,30,730,625,720,592,4,#PB_ScrollArea_Single)
      HideGadget(300,1)
      ButtonGadget(301,290,510,140,40,"",#PB_Button_MultiLine)
      Frame3DGadget(501,280,451,160,1,"",#PB_Frame3D_Flat)
      Frame3DGadget(601,360,451,1,59,"",#PB_Frame3D_Flat)
      For i=0 To 1 ; Gadget 302 - 303
        ButtonGadget(302+i,140+i*300,431,140,40,"",#PB_Button_MultiLine)
        Frame3DGadget(502+i,205+i*300,376,10,1,"",#PB_Frame3D_Flat)
        Frame3DGadget(602+i,210+i*300,376,1,59,"",#PB_Frame3D_Flat)
      Next i
      For i=0 To 3 ; Gadget 304 - 307
        ButtonGadget(304+i,65+i*150,356,140,40,"",#PB_Button_MultiLine)
      Next i
      CloseGadgetList() ; ScrollAreaGadget 300 schlieen
    Case 3
      ScrollAreaGadget(300,230,30,730,625,1210,592,4,#PB_ScrollArea_Single)
      HideGadget(300,1)
      SetGadgetAttribute(300,#PB_ScrollArea_X,240)
      ButtonGadget(301,535,510,140,40,"",#PB_Button_MultiLine)
      Frame3DGadget(501,375,451,460,1,"",#PB_Frame3D_Flat)
      Frame3DGadget(601,605,451,1,59,"",#PB_Frame3D_Flat)
      For i=0 To 1 ; Gadget 302 - 303
        ButtonGadget(302+i,235+i*600,431,140,40,"",#PB_Button_MultiLine)
        Frame3DGadget(502+i,225+i*600,376,160,1,"",#PB_Frame3D_Flat)
        Frame3DGadget(602+i,305+i*600,376,1,59,"",#PB_Frame3D_Flat)
      Next i
      For i=0 To 3 ; Gadget 304 - 307
        ButtonGadget(304+i,85+i*300,356,140,40,"",#PB_Button_MultiLine)
        Frame3DGadget(504+i,150+i*300,301,10,1,"",#PB_Frame3D_Flat)
        Frame3DGadget(604+i,155+i*300,301,1,59,"",#PB_Frame3D_Flat)
      Next i
      For i=0 To 7 ; Gadget 308 - 315
        ButtonGadget(308+i,10+i*150,281,140,40,"",#PB_Button_MultiLine)
      Next i
      CloseGadgetList() ; ScrollAreaGadget 300 schlieen
    Case 4
      ScrollAreaGadget(300,230,30,730,625,2410,592,4,#PB_ScrollArea_Single)
      HideGadget(300,1)
      SetGadgetAttribute(300,#PB_ScrollArea_X,840)
      ButtonGadget(301,1135,510,140,40,"",#PB_Button_MultiLine)
      Frame3DGadget(501,675,451,1060,1,"",#PB_Frame3D_Flat)
      Frame3DGadget(601,1205,451,1,59,"",#PB_Frame3D_Flat)
      For i=0 To 1  ; Gadget 302 - 303
        ButtonGadget(302+i,535+i*1200,431,140,40,"",#PB_Button_MultiLine)
        Frame3DGadget(502+i,375+i*1200,376,460,1,"",#PB_Frame3D_Flat)
        Frame3DGadget(602+i,605+i*1200,376,1,59,"",#PB_Frame3D_Flat)
      Next i
      For i=0 To 3 ; Gadget 304 - 307
        ButtonGadget(304+i,235+i*600,356,140,40,"",#PB_Button_MultiLine)
        Frame3DGadget(504+i,225+i*600,301,160,1,"",#PB_Frame3D_Flat)
        Frame3DGadget(604+i,305+i*600,301,1,59,"",#PB_Frame3D_Flat)
      Next i
      For i=0 To 7 ; Gadget 308 - 315
        ButtonGadget(308+i,85+i*300,281,140,40,"",#PB_Button_MultiLine)
        Frame3DGadget(508+i,150+i*300,226,10,1,"",#PB_Frame3D_Flat)
        Frame3DGadget(608+i,155+i*300,226,1,59,"",#PB_Frame3D_Flat)
      Next i
      For i=0 To 15 ; Gadget 316 - 331
        ButtonGadget(316+i,10+i*150,206,140,40,"",#PB_Button_MultiLine)
      Next i
      CloseGadgetList() ; ScrollAreaGadget 300 schlieen
    Case 5
      ScrollAreaGadget(300,230,30,730,625,4810,592,4,#PB_ScrollArea_Single)
      HideGadget(300,1)
      SetGadgetAttribute(300,#PB_ScrollArea_X,2040)
      ButtonGadget(301,2335,510,140,40,"",#PB_Button_MultiLine)
      Frame3DGadget(501,1275,451,2260,1,"",#PB_Frame3D_Flat)
      Frame3DGadget(601,2405,451,1,59,"",#PB_Frame3D_Flat)
      For i=0 To 1  ; Gadget 302 - 303
        ButtonGadget(302+i,1135+i*2400,431,140,40,"",#PB_Button_MultiLine)
        Frame3DGadget(502+i,675+i*2400,376,1060,1,"",#PB_Frame3D_Flat)
        Frame3DGadget(602+i,1205+i*2400,376,1,59,"",#PB_Frame3D_Flat)
      Next i
      For i=0 To 3  ; Gadget 304 - 307
        ButtonGadget(304+i,535+i*1200,356,140,40,"",#PB_Button_MultiLine)
        Frame3DGadget(504+i,375+i*1200,301,460,1,"",#PB_Frame3D_Flat)
        Frame3DGadget(604+i,605+i*1200,301,1,59,"",#PB_Frame3D_Flat)
      Next i
      For i=0 To 7 ; Gadget 308 - 315
        ButtonGadget(308+i,235+i*600,281,140,40,"",#PB_Button_MultiLine)
        Frame3DGadget(508+i,225+i*600,236,160,1,"",#PB_Frame3D_Flat)
        Frame3DGadget(608+i,305+i*600,236,1,59,"",#PB_Frame3D_Flat)
      Next i
      For i=0 To 15 ; Gadget 316 - 331
        ButtonGadget(316+i,85+i*300,206,140,40,"",#PB_Button_MultiLine)
        Frame3DGadget(516+i,150+i*300,152,10,1,"",#PB_Frame3D_Flat)
        Frame3DGadget(616+i,155+i*300,152,1,59,"",#PB_Frame3D_Flat)
      Next i
      For i=0 To 31 ; Gadget 332 - 363
        ButtonGadget(332+i,10+i*150,131,140,40,"",#PB_Button_MultiLine)
      Next i
      CloseGadgetList() ; ScrollAreaGadget 300 schlieen
    Case 6 To 7
      ScrollAreaGadget(300,230,30,730,625,9610,592,4,#PB_ScrollArea_Single)
      HideGadget(300,1)
      SetGadgetAttribute(300,#PB_ScrollArea_X,4440)
      ButtonGadget(301,4735,510,140,40,"",#PB_Button_MultiLine)
      Frame3DGadget(501,2475,451,4660,1,"",#PB_Frame3D_Flat)
      Frame3DGadget(601,4805,451,1,59,"",#PB_Frame3D_Flat)
      For i=0 To 1  ; Gadget 302 - 303
        ButtonGadget(302+i,2335+i*4800,431,140,40,"",#PB_Button_MultiLine)
        Frame3DGadget(502+i,1275+i*4800,376,2260,1,"",#PB_Frame3D_Flat)
        Frame3DGadget(602+i,2405+i*4800,376,1,59,"",#PB_Frame3D_Flat)
      Next i
      For i=0 To 3  ; Gadget 304 - 307
        ButtonGadget(304+i,1135+i*2400,356,140,40,"",#PB_Button_MultiLine)
        Frame3DGadget(504+i,675+i*2400,301,1060,1,"",#PB_Frame3D_Flat)
        Frame3DGadget(604+i,1205+i*2400,301,1,59,"",#PB_Frame3D_Flat)
      Next i
      For i=0 To 7  ; Gadget 308 - 315
        ButtonGadget(308+i,535+i*1200,281,140,40,"",#PB_Button_MultiLine)
        Frame3DGadget(508+i,375+i*1200,226,460,1,"",#PB_Frame3D_Flat)
        Frame3DGadget(608+i,605+i*1200,226,1,59,"",#PB_Frame3D_Flat)
      Next i
      For i=0 To 15 ; Gadget 316 - 331
        ButtonGadget(316+i,235+i*600,206,140,40,"",#PB_Button_MultiLine)
        Frame3DGadget(516+i,225+i*600,152,160,1,"",#PB_Frame3D_Flat)
        Frame3DGadget(616+i,305+i*600,152,1,59,"",#PB_Frame3D_Flat)
      Next i
      For i=0 To 31 ; Gadget 332 - 363
        ButtonGadget(332+i,85+i*300,131,140,40,"",#PB_Button_MultiLine)
        Frame3DGadget(532+i,150+i*300,76,10,1,"",#PB_Frame3D_Flat)
        Frame3DGadget(632+i,155+i*300,76,1,59,"",#PB_Frame3D_Flat)
      Next i
      For i=0 To 63 ; Gadget 364 - 427
        ButtonGadget(364+i,10+i*150,56,140,40,"",#PB_Button_MultiLine)
      Next i
      CloseGadgetList() ; ScrollAreaGadget 300 schlieen
  EndSelect
  ;
  For p=1 To gadnum
    txt$=Person(vor(p))\nam+Chr(13)+Person(vor(p))\vor
    If (txt$<>Chr(13)) And (Left(txt$,5)<>"ZZZZZ")
      If (generation=7) And (p>63) And (Person(vor(2*p))\nam<>"")
        OpenGadgetList(300)
          Frame3DGadget(gadnum+1000,GadgetX(300+p)+70,GadgetY(300+p)-55,1,55,"",#PB_Frame3D_Flat)
        CloseGadgetList() ; ScrollAreaGadget 300 schlieen
      EndIf
      SetGadgetText(300+p,txt$)
      HideGadget(300+p,0)
      If p=2*(p/2)
        HideGadget(500+p/2,0)
        HideGadget(600+p/2,0)
      EndIf
    Else
      If Left(txt$,5)="ZZZZZ"
        SetGadgetText(300+p,"Kein Partner")
        DisableGadget(300+p,1)
      Else
        HideGadget(300+p,1)
      EndIf
      If p=2*(p/2)
        HideGadget(500+p/2,1)
        HideGadget(600+p/2,1)
      EndIf
    EndIf
  Next p
  HideGadget(300,0)
  txt$="Zurck: Verbindungen anzeigen oder Person anklicken"
  Hilfe(0,txt$)
EndProcedure ; Vorfahren
;
Procedure InfoPerson()
  If prs(5)=0
    ProcedureReturn
  EndIf
  Repeat
    i$=GetGadgetItemText(281,k,0)
    j$=GetGadgetItemText(281,k+1,0)
    If j$<>""
      i$+Chr(35)+Chr(35)
    EndIf
    info$+i$
    k+1
  Until j$=""
  info$=Trim(info$)
  info$=Parse(info$)
  If info$=#fehler
    ProcedureReturn
  EndIf
  Person(prs(5))\inf=info$
  StrukturInDaten(prs(5))
EndProcedure ; InfoPerson
;
Procedure Infotest()
  ggt$=GetGadgetText(281)
  lll=Len(ggt$)
  If lll>#info
    tit$="Informationen"
    txt$="Die maximale Textlnge ist berschritten.    "
    txt$+Chr(13)
    txt$+"Die beiden letzten Zeichen werden wieder entfernt.    "
    MessageRequester(tit$,txt$,#MB_ICONEXCLAMATION)
    SetGadgetText(281,Left(ggt$,lll-2))
  EndIf
EndProcedure ; Infotest
;
Procedure Suchen(typ)
  Select typ
    Case 1
      tit$="Person suchen"
      txt1$="Gesuchte Person (Name, Vorname):"
      Repeat
        quit=1
        da$=InputRequester(tit$,txt1$,"")
        da$=Trim(da$)
        da$=Parse(da$)
        If da$=#fehler
          da$=""
        EndIf  
        If da$=""
          ProcedureReturn
        EndIf  
        kom1=FindString(da$,",",1)
        kom2=FindString(da$,",",kom1+1)
        If (kom1>1) And (kom2=0)
          nm$=Left(da$,kom1-1)
          nm$=Trim(nm$)
          vr$=Mid(da$,kom1+1)
          vr$=Trim(vr$)
        EndIf
        If (nm$="") Or (vr$="")
          txt2$="Fehlerhafte Eingabe:    "
          txt2$+Chr(13)
          txt2$+da$+Space(4)
          txt2$+Chr(13)+Chr(13)
          txt2$+"Geben Sie den Familiennamen und den    "
          txt2$+Chr(13)
          txt2$+"Vornamen auf folgende Weise ein:    "
          txt2$+Chr(13)+Chr(13)
          txt2$+Space(12)+"Name, Vorname    "
          res=MessageRequester(tit$,txt2$,#MB_OKCANCEL|#MB_ICONSTOP|#MB_DEFBUTTON2)
          If res=#PB_MessageRequester_Cancel
            ProcedureReturn
          Else
            quit=0
          EndIf  
        EndIf
      Until quit=1
      ;
      txt$="Eine Person mit dem Namen "+vr$+" "+nm$+Space(4)
      txt$+Chr(13)
      txt$+"wurde nicht gefunden.    "
      ;
      For k=1 To perzahl
        id=idx(k)
        nmid$=Person(id)\nam
        vrid$=Person(id)\vor
        vrl$=Parse(vrid$,2)
        If (nmid$=nm$) And ((vrid$=vr$) Or (vrl$=vr$))
          pgad=k
          fnd=1
          VerbindungenAnzeigen(id)
          Break
        EndIf      
      Next k
      If fnd=1
        Sortierung(0)
        ProcedureReturn
      EndIf
      ;
      For k=1 To perzahl
        id=idx(k)
        nmid$=Person(id)\nam
        nmr$=Parse(nmid$,1)
        nml$=Parse(nmr$,2)
        nmll$=Parse(nmid$,3)
        vrid$=Person(id)\vor
        vrl$=Parse(vrid$,2)
        If ((nmr$=nm$) Or (nml$=nm$) Or (nmll$=nm$)) And ((vrid$=vr$) Or (vrl$=vr$))
          pgad=k
          fnd=1
          VerbindungenAnzeigen(id)
          If (nmr$=nm$) Or (nml$=nm$) Or (nmll$=nm$)
            txt$+Chr(13)+Chr(13)+"Vielleicht ist "+vrid$+" "+nmid$+Space(4)
            txt$+Chr(13)
            txt$+"die gesuchte Person.    "
            MessageRequester(tit$,txt$,#MB_ICONINFORMATION) 
          EndIf
          Break
        EndIf      
      Next k
      If fnd=1
        Sortierung(0)
        ProcedureReturn
      EndIf
      ;
      For k=1 To perzahl
        id=idx(k)
        nmid$=Person(id)\nam
        nmr$=Parse(nmid$,1)
        If (nmid$=nm$) Or (nmr$=nm$)
          For j=10 To 170 Step 20
            vrid$=Person(Person(id)\fam[j])\vor
            vrl$=Parse(vrid$,2)
            If (vrid$=vr$) Or (vrl$=vr$)
              nm2$=Person(Person(id)\fam[j])\nam
              txt1$=Chr(13)+Chr(13)
              If Person(id)\gen="f"
                pt$="der Partnerin    "
              Else
                pt$="dem Partner    "
              EndIf    
              txt1$+"Ist "+vr$+" "+nm2$+" mit "+pt$
              txt1$+Chr(13)
              txt1$+Person(id)\vor+" "+nmid$+" die gesuchte Person?    "
              id2=Person(id)\fam[j]
              pgad=inv(id2)
              Sortierung(0)
              VerbindungenAnzeigen(id2)
              res=MessageRequester(tit$,txt$+txt1$,#PB_MessageRequester_YesNo|#MB_ICONQUESTION|#MB_DEFBUTTON2)
              If res=#PB_MessageRequester_Yes
                fnd=1
                Break 2
              EndIf  
            EndIf  
          Next j
        EndIf
      Next k
      If fnd=0
        MessageRequester(tit$,txt$,#MB_ICONINFORMATION)
      EndIf
    Case 2
      tit$="Familiennamen suchen"
      txt$="Gesuchter Name:"
      nm$=InputRequester(tit$,txt$,"")
      nm$=Trim(nm$)
      nm$=Parse(nm$)
      If nm$=#fehler
        nm$=""
      EndIf  
      If nm$=""
        ProcedureReturn
      EndIf
      ;
      For k=1 To perzahl
        id=idx(k)
        nmid$=Person(id)\nam
        If nmid$=nm$
          pgad=k
          VerbindungenAnzeigen(id)
          fnd=1
          Break
        EndIf
      Next k
      If fnd=1
        Sortierung(0)
        ProcedureReturn
      EndIf
      ;
      For k=1 To perzahl
        id=idx(k)
        nmid$=Person(id)\nam
        nmr$=Parse(nmid$,1)
        nml$=Parse(nmr$,2)
        nmlr$=Parse(nmid$,3)
        If (nmr$=nm$) Or (nml$=nm$) Or (nmlr$=nm$)
          pgad=k
          VerbindungenAnzeigen(id)
          fnd=1
          Break
        EndIf
      Next k
      If fnd=1
        Sortierung(0)
        ProcedureReturn
      EndIf
      ;
      txt$="Eine Person mit dem Namen "+nm$+Space(4)
      txt$+Chr(13)
      txt$+"wurde nicht gefunden.    "
      MessageRequester(tit$,txt$,#MB_ICONINFORMATION)
    Case 3
      tit$="Vornamen suchen"
      txt$="Gesuchter Vorname:"
      vr$=InputRequester(tit$,txt$,"")
      vr$=Trim(vr$)
      vr$=Parse(vr$)
      If vr$=#fehler
        vr$=""
      EndIf  
      If vr$=""
        ProcedureReturn
      EndIf
      ;
      For k=1 To perzahl
        id=idx(k)
        vrid$=Person(id)\vor
        If vrid$=vr$
          pgad=k
          VerbindungenAnzeigen(id)
          fnd=1
          Break
        EndIf
      Next k
      If fnd=1
        Sortierung(2)
        ProcedureReturn
      EndIf
      ;
      For k=1 To perzahl
        id=idx(k)
        vrid$=Person(id)\vor
        vrl$=Parse(vrid$,2)
        If (vrid$=vr$) Or (vrl$=vr$)
          pgad=k
          VerbindungenAnzeigen(id)
          fnd=1
          Break
        EndIf
      Next k
      If fnd=1
        Sortierung(2)
        ProcedureReturn
      EndIf
      ;
      txt$="Eine Person mit dem Namen "+nm$+Space(4)
      txt$+Chr(13)
      txt$+"wurde nicht gefunden.    "
      MessageRequester(tit$,txt$,#MB_ICONINFORMATION)
  EndSelect   
EndProcedure ; Suchen
;
;- BEARBEITUNG
Procedure VerbindungHin(gad)
  ; gad: Nr. des Gadgets fr die zu verbindende Person
  ; (wurde in Verbindungsanzeige angeklickt -> Aufruf VerbindungHin()
  p=prs(5)        ; Nr. der Zentralperson
  neu=idx(pgad)   ; Nr. der zu verbindenden Person (wurde in der Liste angeklickt)
  If prs(gad)>0   ; Gadget gad ist bereits besetzt
    MessageBeep_(#MB_ICONHAND)
    ProcedureReturn
  EndIf
  For i=5 To 189
    If prs(i)=neu ; zu verbindende Person ist bereits in der Anzeige enthalten
      tit$="Verbindung hinzufgen"
      txt$=Person(neu)\vor+" "+Person(neu)\nam+" wird bereits angezeigt.    "
      MessageRequester(tit$,txt$,#MB_ICONSTOP)
      ProcedureReturn
    EndIf
  Next i
  ;
  Select gad
    Case 8,9
      If Person(neu)\gen="m"
        abbruch=VaterHin(p,neu)
      Else
        abbruch=MutterHin(p,neu)
      EndIf
    Case 10,30,50,70,90,110,130,150,170
      abbruch=PartnerHin(p,neu,gad)
    Default
      abbruch=KindHin(p,neu,gad)
  EndSelect
  If abbruch
    ProcedureReturn
  EndIf
  ;
  If Zyklentest(neu)>0
    tit$="Eingabefehler (zyklischer Graph)"
    txt$=Person(neu)\vor+" "+Person(neu)\nam
    txt$+" wre "
    If Person(neu)\gen="m"
      txt$+"sein"
    Else
      txt$+"ihr"
    EndIf
    txt$+" eigener Vorfahr.    "
    MessageRequester(tit$,txt$,#MB_ICONSTOP)
    VerbindungWeg(gad)
    zykl=0
  EndIf
  VerbindungenBearbeiten()
EndProcedure ; VerbindungHin
;
Procedure.i PartnerHin(p,neu,gad)
  tit$="Eingabe Partner"
  g=Person(neu)\fam[0]
  ; Partner -> Zentralperson:
  Person(p)\fam[gad]=neu
  Person(p)\fam[0]+1
  txt$=Person(neu)\nam+Chr(13)+Person(neu)\vor
  SetGadgetText(gad,txt$)
  prs(gad)=neu
  ; Zentralperson -> Partner:
  Person(neu)\fam[20*g+10]=p
  Person(neu)\fam[0]+1
EndProcedure ; PartnerHin
;
Procedure.i VaterHin(p,neu)
  tit$="Eingabe Vater"
  ; Zugehrige Mutter erfragen:
  prt=Person(neu)\fam[0]
  nopar=1
  parnum=1
  pargad=10
  If prt>0
    For i=1 To prt
      par=Person(neu)\fam[20*i-10]
      If Left(Person(par)\nam,5)="ZZZZZ"
        txt$="Hat nur der Vater dieses Kind adoptiert?    "
        psdpar=1
      Else
        txt$="Ist "+Person(par)\vor+" "+Person(par)\nam
        If Person(par)\gen="f"
          txt$+" die zugehrige Mutter?    "
        Else
          txt$+" der zugehrige Partner?    "
        EndIf
      EndIf
      res=MessageRequester(tit$,txt$,#PB_MessageRequester_YesNo|#MB_ICONQUESTION|#MB_DEFBUTTON2)
      If res=#PB_MessageRequester_Yes
        parnum=i 
        pargad=20*i-10
        nopar=0
        If psdpar=1
          Person(p)\vat[1]=1
        EndIf
        Break
      Else
        parnum+1
        pargad=20*parnum-10
      EndIf
    Next i
  EndIf
  If Person(neu)\fam[0]=9 ; kein virtueller Partner mglich
    ProcedureReturn 1
  EndIf
  If (nopar=1) And (psdpar=0)
    txt$="Diesem Vater ist keine Partnerin zugeordnet.    "
    txt$+Chr(13)
    txt$+"Hat er dieses Kind allein adoptiert?    "
    res=MessageRequester(tit$,txt$,#PB_MessageRequester_YesNo|#MB_ICONQUESTION|#MB_DEFBUTTON2)
    If res=#PB_MessageRequester_Yes
      VirtPartner(neu)
      par=perzahl
      Person(p)\vat[1]=1
      nopar=0
    EndIf
  EndIf
  If nopar=1
    txt$="Die zugehrige Mutter kann nicht zugeordnet werden.    "
    MessageRequester(tit$,txt$,#MB_ICONSTOP)
    ProcedureReturn 1
  EndIf
  ;
  g1=Person(neu)\fam[parnum]
  If g1=19
    txt$="Dem Vater und der zugehrigen Mutter sind bereits 19 Kinder zugeordnet.    "
    MessageRequester(tit$,txt$,#MB_ICONSTOP)
    ProcedureReturn 1
  EndIf
  ;
  parpargad=-10
  Repeat
    parpargad+20
    parparnum+1
  Until Person(par)\fam[parpargad]=neu
  g2=Person(par)\fam[parparnum]
  If g2=19
    txt$=Person(p)\vor+" "+Person(p)\nam
    txt$+" kann der zugehrigen Mutter nicht zugeordnet werden.    "
    MessageRequester(tit$,txt$,#MB_ICONSTOP)
    ProcedureReturn 1
  EndIf
  ; Zentralperson -> Vater:
  Person(neu)\fam[pargad+g1+1]=p
  Person(neu)\fam[parnum]+1
  ; Zentralperson -> Mutter:
  Person(par)\fam[parpargad+g2+1]=p
  Person(par)\fam[parparnum]+1
  ; Vater -> Zentralperson:
  Person(p)\vat[0]=neu
  txt$=Person(neu)\nam+Chr(13)+Person(neu)\vor
  SetGadgetText(8,txt$)
  prs(8)=neu
  ; Mutter -> Zentralperson:
  Person(p)\mut[0]=par
  txt$=Person(par)\nam+Chr(13)+Person(par)\vor
  If Left(txt$,5)<>"ZZZZZ"
    SetGadgetText(9,txt$)
    DisableGadget(9,0)
  Else
    SetGadgetText(9,"Kein Partner")
    DisableGadget(9,1)
  EndIf
  prs(9)=par
  ;
  If Person(neu)\gen=Person(par)\gen
    txt$="Bei gleichgeschlechtlichen Partnerschaften nimmt das    "
    txt$+Chr(13)
    txt$+"Programm zunchst an, dass das Kind adoptiert wurde.    "
    MessageRequester(tit$,txt$,#MB_ICONINFORMATION)
    Person(p)\vat[1]=1
    Person(p)\mut[1]=1
  EndIf
EndProcedure ; VaterHin
;
Procedure.i MutterHin(p,neu)
  tit$="Eingabe Mutter"
  ; Zugehrigen Vater erfragen:
  prt=Person(neu)\fam[0]
  nopar=1
  parnum=1
  pargad=10
  If prt>0
    For i=1 To prt
      par=Person(neu)\fam[20*i-10]
      If Left(Person(par)\nam,5)="ZZZZZ"
        txt$="Hat nur die Mutter dieses Kind adoptiert?    "
        psdpar=1
      Else
        txt$="Ist "+Person(par)\vor+" "+Person(par)\nam
        If Person(par)\gen="m"
          txt$+" der zugehrige Vater?    "
        Else
          txt$+" die zugehrige Partnerin?    "
        EndIf
      EndIf
      res=MessageRequester(tit$,txt$,#PB_MessageRequester_YesNo|#MB_ICONQUESTION|#MB_DEFBUTTON2)
      If res=#PB_MessageRequester_Yes
        parnum=i
        pargad=20*i-10
        nopar=0
        If psdpar=1
          Person(p)\mut[1]=1
        EndIf
        Break
      Else
        parnum+1
        pargad=20*parnum-10
      EndIf
    Next i
  EndIf
  If Person(neu)\fam[0]=9 ; kein virtueller Partner mglich
    ProcedureReturn 1
  EndIf
  If (nopar=1) And (psdpar=0)
    txt$="Dieser Mutter ist kein Partner zugeordnet.    "
    txt$+Chr(13)
    txt$+"Hat sie dieses Kind allein adoptiert?    "
    res=MessageRequester(tit$,txt$,#PB_MessageRequester_YesNo|#MB_ICONQUESTION|#MB_DEFBUTTON2)
    If res=#PB_MessageRequester_Yes
      VirtPartner(neu)
      par=perzahl
      Person(p)\mut[1]=1
      nopar=0
    EndIf
  EndIf
  If nopar=1
    txt$="Der zugehrige Vater kann nicht zugeordnet werden.    "
    MessageRequester(tit$,txt$,#MB_ICONSTOP)
    ProcedureReturn 1
  EndIf
  ;
  g1=Person(neu)\fam[parnum]
  If g1=19
    txt$="Der Mutter und dem zugehrigen Vater sind bereits 19 Kinder zugeordnet.    "
    MessageRequester(tit$,txt$,#MB_ICONSTOP)
    ProcedureReturn 1
  EndIf
  ;
  parpargad=-10
  Repeat
    parpargad+20
    parparnum+1
  Until Person(par)\fam[parpargad]=neu
  g2=Person(par)\fam[parparnum]
  If g2=19
    txt$=Person(p)\vor+" "+Person(p)\nam
    txt$+" kann dem zugehrigen Vater nicht zugeordnet werden.    "
    MessageRequester(tit$,txt$,#MB_ICONSTOP)
    ProcedureReturn 1
  EndIf
  ; Zentralperson -> Mutter:
  Person(neu)\fam[pargad+g1+1]=p
  Person(neu)\fam[parnum]+1
  ; Zentralperson -> Vater:
  Person(par)\fam[parpargad+g2+1]=p
  Person(par)\fam[parparnum]+1
  ; Mutter -> Zentralperson:
  Person(p)\mut[0]=neu
  txt$=Person(neu)\nam+Chr(13)+Person(neu)\vor
  SetGadgetText(9,txt$)
  prs(9)=neu
  ; Vater -> Zentralperson:
  Person(p)\vat[0]=par
  txt$=Person(par)\nam+Chr(13)+Person(par)\vor
  If Left(txt$,5)<>"ZZZZZ"
    SetGadgetText(8,txt$)
    DisableGadget(8,0)
  Else
    SetGadgetText(8,"Kein Partner")
    DisableGadget(8,1)
  EndIf
  prs(8)=par
  ;
  If Person(neu)\gen=Person(par)\gen
    txt$="Bei gleichgeschlechtlichen Partnerschaften nimmt das    "
    txt$+Chr(13)
    txt$+"Programm zunchst an, dass das Kind adoptiert wurde.    "
    MessageRequester(tit$,txt$,#MB_ICONINFORMATION)
    Person(p)\vat[1]=1
    Person(p)\mut[1]=1
  EndIf
EndProcedure ; MutterHin
;
Procedure.i KindHin(p,neu,gad)
  tit$="Eingabe Kind"
  ; Sind dem Kind bereits Eltern zugeordnet?
  If Person(neu)\vat[0]>0
    txt$=Person(neu)\vor+" "+Person(neu)\nam+" sind bereits Eltern zugeordnet.    "
    MessageRequester(tit$,txt$,#MB_ICONSTOP)
    ProcedureReturn 1
  EndIf
  ; Welcher Partner par von p gehrt zu dem eingegebenen Kind?
  For i=30 To 190 Step 20
    If gad<i
      par=prs(i-20)
      parnum=(i-10)/20
      Break
    EndIf
  Next i
  ; Ist das eingegebene Kind Partner des Partners par von p?
  For i=10 To 170 Step 20
    If Person(par)\fam[i]=neu
      txt$=Person(neu)\vor+" "+Person(neu)\nam+" ist Partner von "
      txt$+Person(par)\vor+" "+Person(par)\nam+".    "
      MessageRequester(tit$,txt$,#MB_ICONSTOP)
      ProcedureReturn 1
    EndIf
  Next i
  ;  Partner p bei par suchen:
  parpar=-10
  Repeat 
    parpar+20
    parparnum+1
  Until Person(par)\fam[parpar]=p
  ; Kind -> Zentralperson p:
  Person(p)\fam[gad]=neu
  Person(p)\fam[parnum]+1  
  txt$=Person(neu)\nam+Chr(13)+Person(neu)\vor
  SetGadgetText(gad,txt$)
  prs(gad)=neu
  ; Zentralperson p und Partner par -> Kind
  If Person(p)\gen="m"
    Person(neu)\vat[0]=p
    Person(neu)\mut[0]=par
  Else
    Person(neu)\mut[0]=p
    Person(neu)\vat[0]=par
  EndIf
  ; Kind -> Partner par:
  pk=Person(par)\fam[parparnum]
  Person(par)\fam[parpar+pk+1]=neu
  Person(par)\fam[parparnum]+1
  ;
  If Person(p)\gen=Person(par)\gen
    txt$="Bei gleichgeschlechtlichen Partnerschaften nimmt das    "
    txt$+Chr(13)
    txt$+"Programm zunchst an, dass das Kind adoptiert wurde.    "
    MessageRequester(tit$,txt$,#MB_ICONINFORMATION)
    Person(neu)\vat[1]=1
    Person(neu)\mut[1]=1
  EndIf
EndProcedure ; KindHin
;
Procedure VerbindungWeg(gad)
  ; gad: Nr. des Gadgets fr die zu lschende Person
  ; (wurde in der Verbindungsanzeige angeklickt -> Aufruf VerbindungWeg()
  If prs(gad)=0
    ProcedureReturn
  EndIf
  p=prs(5)
  Select gad
    Case 8,9
      ElternWeg(p)
    Case 10,30,50,70,90,110,130,150,170
      PartnerWeg(p,gad)
    Default
      KindWeg(p,gad)
  EndSelect
  weg=0
  VirtEntfernen()
  VerbindungenBearbeiten()
EndProcedure ; VerbindungWeg
;
Procedure PartnerWeg(p,gad)
  If prs(gad+1)<>0
    tit$="Verbindung zu Partner entfernen"
    txt$="Auch die Verbindungen zu gemeinsamen Kindern werden entfernt.    "
    res=MessageRequester(tit$,txt$,#MB_OKCANCEL|#MB_ICONINFORMATION|#MB_DEFBUTTON2)
    If res=#PB_MessageRequester_Cancel
      ProcedureReturn
    EndIf
  EndIf
  ; Gemeisame Kinder weg:
  While prs(gad+1)>0
    KindWeg(p,gad+1) ; Kind gad+2 -> gad+1 !
    For i=gad+1 To gad+18
      prs(i)=prs(i+1)
    Next i
  Wend
  ent=prs(gad)
  ; Partner bei Zentralperson weg:
  Person(p)\fam[gad]=0
  Person(p)\fam[0]-1
  SetGadgetText(gad,"")
  prs(gad)=0
  ; zugehriges Partnerfeld bei Partner suchen:
  g=-10
  Repeat
    g+20
  Until Person(ent)\fam[g]=p
  ; Zentralperson bei Partner weg:
  Person(ent)\fam[g]=0
  Person(ent)\fam[0]-1
  ; leere Felder auffllen:
  LueckenPartner(p,gad)
  LueckenPartner(ent,g)
EndProcedure ; PartnerWeg
;
Procedure ElternWeg(p)
  If zykl=0
    tit$="Verbindung zu Eltern entfernen"
    txt$="Die Verbindung zu beiden Elternteilen wird entfernt.    "
    res=MessageRequester(tit$,txt$,#MB_OKCANCEL|#MB_ICONINFORMATION|#MB_DEFBUTTON2)
    If res=#PB_MessageRequester_Cancel
      ProcedureReturn
    EndIf
  EndIf
  v=prs(8)
  m=prs(9)
  Repeat
    pv+1
  Until Person(v)\fam[20*pv-10]=m
  Repeat
    pm+1
  Until Person(m)\fam[20*pm-10]=v
  ; Vater bei Zentralperson weg:
  Person(p)\vat[0]=0
  Person(p)\vat[1]=0
  SetGadgetText(8,"")
  prs(8)=0
  ; Mutter bei Zentralperson weg:
  Person(p)\mut[0]=0
  Person(p)\mut[1]=0
  SetGadgetText(9,"")
  prs(9)=0
  ; Zentralperson bei Vater suchen:
  g=10
  Repeat
    g+1
  Until Person(v)\fam[g]=p
  ; Zentralperson bei Vater weg:
  Person(v)\fam[g]=0
  Person(v)\fam[pv]-1
  ; Zentralperson bei Mutter suchen:
  g=10
  Repeat
    g+1
  Until Person(m)\fam[g]=p
  ; Zentralperson bei Mutter weg:
  Person(m)\fam[g]=0
  Person(m)\fam[pm]-1
EndProcedure ; ElternWeg
;
Procedure KindWeg(p,gad)
  ent=prs(gad)
  For i=30 To 190 Step 20
    If gad<i
      gadpar=i-20
      par=prs(gadpar)
      parnum=(i-10)/20
      Break
    EndIf
  Next i
  ; Kind bei Zentralperson weg:
  Person(p)\fam[gad]=0
  Person(p)\fam[parnum]-1
  SetGadgetText(gad,"")
  prs(gad)=0
  ; Zentralperson und Partner bei Kind weg:
  Person(ent)\vat[0]=0
  Person(ent)\vat[1]=0
  Person(ent)\mut[0]=0
  Person(ent)\mut[1]=0
  ; Kind bei Partner par weg:
  For k=10 To 170 Step 20
    pk+1
    For i=k+1 To k+19
      If Person(par)\fam[i]=ent
        g=i
        Break 2
      EndIf
    Next i
  Next k
  Person(par)\fam[g]=0
  Person(par)\fam[pk]-1
  ; leere Felder auffllen:
  LueckenKinder(p,gad)
  LueckenKinder(par,g)
  ; Virtuelle Partner entfernen:
  If (Person(par)\fam[pk]=0) And (Left(Person(par)\nam,5)="ZZZZZ")
    PartnerWeg(prs(5),gadpar)
    Entfernen(par,0)
  EndIf
EndProcedure ; KindWeg
;
Procedure LueckenPartner(pp,lu)
  prt=20*Person(pp)\fam[0]+10 ; mit Partnerzahl vor Entfernen
  If lu=prt
    ProcedureReturn
  EndIf
  For k=lu To prt-20 Step 20
    For i=k To k+19
     Person(pp)\fam[i]=Person(pp)\fam[i+20]
    Next i
  Next k
  For i=prt To prt+19
    Person(pp)\fam[i]=0
  Next i
  lunum=(lu+10)/20
  prtnum=(prt+10)/20
  For k=lunum To prtnum-1
    Person(pp)\fam[k]=Person(pp)\fam[k+1]
  Next k
  Person(pp)\fam[prtnum]=0
EndProcedure ; LueckenPartner
;
Procedure LueckenKinder(pp,lu)
  For k=29 To 189 Step 20
    If (lu<k) And (lu<>k-20)
      For i=lu To k-1
        Person(pp)\fam[i]=Person(pp)\fam[i+1]
      Next i
      Person(pp)\fam[k]=0
      Break
    EndIf
  Next k
EndProcedure ; LueckenKinder
;
Procedure StammdatenBearb()
  If Prueftext()=stamm$ 
    If prs(5)=0
      Initialisierung()
    EndIf
    ProcedureReturn
  EndIf
  tit$="Stammdaten bearbeiten"
  namalt$=Person(prs(5))\nam
  nam$=GetGadgetText(251)
  nam$=Parse(nam$)
  If nam$=#fehler
    nam$=namalt$
  EndIf
  voralt$=Person(prs(5))\vor
  vor$=GetGadgetText(252)
  vor$=Parse(vor$)
  If vor$=#fehler
    vor$=voralt$
  EndIf
  geb$=GetGadgetText(253)
  ste$=GetGadgetText(254)
  If GetGadgetState(255)=1
    gen$="m"
  ElseIf GetGadgetState(256)=1
    gen$="f"
  EndIf
  If nam$=""
    nam$=NNnummer()
    txt$="Der fehlende Familienname wird durch "+nam$+" ersetzt.    "
    MessageRequester(tit$,txt$,#MB_ICONINFORMATION)
  EndIf
  If vor$=""
    vor$="?"
    txt$="Der fehlende Vorname wird durch ? ersetzt.    "
    MessageRequester(tit$,txt$,#MB_ICONINFORMATION)
  EndIf
  If geb$=""
    geb$="0"
  EndIf
  If ste$=""
    ste$="0"
  EndIf
  ;
  p=prs(5)
  Person(p)\nam=nam$
  Person(p)\vor=vor$
  Person(p)\gen=gen$
  Person(p)\geb=geb$
  Person(p)\ste=ste$
  StrukturInDaten(p) ; damit in Liste() sortiert werden kann
  Liste()
EndProcedure ; StammdatenBearb
;
Procedure NeuePersonBearb()
  tit$="Person hinzufgen"
  nam$=GetGadgetText(251)
  nam$=Parse(nam$)
  If nam$=#fehler
    ProcedureReturn
  EndIf
  vor$=GetGadgetText(252)
  vor$=Parse(vor$)
  If vor$=#fehler
    ProcedureReturn
  EndIf  
  geb$=GetGadgetText(253)
  ste$=GetGadgetText(254)
  ;
  If (Prueftext()="10") Or (Prueftext()="01")
    If prs(5)=0
      Initialisierung()
    EndIf
    ProcedureReturn
  EndIf
  If nam$=""
    nam$=NNnummer()
    txt$="Der fehlende Familienname wird durch "+nam$+" ersetzt.    "
    MessageRequester(tit$,txt$,#MB_ICONINFORMATION)  
  EndIf
  If vor$=""
    vor$="?"
    txt$="Der fehlende Vorname wird durch ? ersetzt.    "
    MessageRequester(tit$,txt$,#MB_ICONINFORMATION)
  EndIf
  If GetGadgetState(255)=1
    gen$="m"
  ElseIf GetGadgetState(256)=1
    gen$="f"
  EndIf
  If geb$=""
    geb$="0"
  EndIf
  If ste$=""
    ste$="0"
  EndIf
  ;
  For k=1 To perzahl
    If (nam$=Person(k)\nam) And (vor$=Person(k)\vor)
      gleich+1
    EndIf
  Next k
  If gleich>0
    If gleich>1
      txt1$=Str(gleich)+" Personen "
      txt2$=" sind "
    Else
      txt1$="Eine Person "
      txt2$=" ist "
    EndIf
    txt$=txt1$+"mit dem Namen "+vor$+" "+nam$+txt2$+"bereits in der "
    txt$+"Datei "+GetFilePart(datei$)+" enthalten.  "
    txt$+Chr(13)
    txt$+"Soll "+vor$+" "+nam$+" trotzdem in diese Datei aufgenommen werden?    "
    res=MessageRequester(tit$,txt$,#MB_YESNO|#MB_ICONQUESTION|#MB_DEFBUTTON2)
    If res=#PB_MessageRequester_No
      ProcedureReturn
    EndIf
  EndIf
  ;
  perzahl+1
  NeuDim()
  Person(perzahl)\nam=nam$
  Person(perzahl)\vor=vor$
  Person(perzahl)\gen=gen$
  Person(perzahl)\geb=geb$
  Person(perzahl)\ste=ste$
  Person(perzahl)\vat[0]=0
  Person(perzahl)\vat[1]=0
  Person(perzahl)\mut[0]=0
  Person(perzahl)\mut[1]=0
  For i=0 To 189
    Person(perzahl)\fam[i]=0
  Next i
  StrukturInDaten(perzahl)  ; damit in Liste() sortiert werden kann
  Liste()
EndProcedure ; NeuePersonBearb
;
Procedure VirtPartner(p)
  perzahl+1
  NeuDim()
  Person(perzahl)\nam=ZZnummer()
  Person(perzahl)\vor="Z"
  Person(perzahl)\gen="0"
  Person(perzahl)\geb="0"
  Person(perzahl)\ste="0"
  Person(perzahl)\fam[0]=1
  Person(perzahl)\fam[10]=p
  Person(p)\fam[0]+1
  fm=20*Person(p)\fam[0]-10
  Person(p)\fam[fm]=perzahl
  StrukturInDaten(perzahl)
  Liste()
EndProcedure ; VirtPartner
;
Procedure Entfernen(p,ab)
  If ab=1
    tit$="Person entfernen"
    txt$+"Soll "
    txt$+Person(p)\vor+" "+Person(p)\nam
    txt$+" entfernt werden?    "
    res=MessageRequester(tit$,txt$,#PB_MessageRequester_YesNo|#MB_ICONQUESTION|#MB_DEFBUTTON2)
    If res=#PB_MessageRequester_No
      ProcedureReturn
    EndIf
  EndIf
  ; Verbindungen zu Nr. p+1 ... perzahl um 1 vermindern:
  For k=1 To perzahl
    For q=p+1 To perzahl  
      If Person(k)\vat[0]=q
        Person(k)\vat[0]=q-1
      EndIf
      If Person(k)\mut[0]=q
        Person(k)\mut[0]=q-1
      EndIf
      For i=10 To 189
        If Person(k)\fam[i]=q
          Person(k)\fam[i]=q-1
        EndIf
      Next i
    Next q
  Next k
  ; Daten von p+1 ... perzahl um eine Nummer vermindern
  For k=p To perzahl-1
    Person(k)\nam=Person(k+1)\nam
    Person(k)\vor=Person(k+1)\vor
    Person(k)\gen=Person(k+1)\gen
    Person(k)\geb=Person(k+1)\geb
    Person(k)\ste=Person(k+1)\ste
    Person(k)\vat[0]=Person(k+1)\vat[0]
    Person(k)\vat[1]=Person(k+1)\vat[1]
    Person(k)\mut[0]=Person(k+1)\mut[0]
    Person(k)\mut[1]=Person(k+1)\mut[1]
    For i=0 To 189
      Person(k)\fam[i]=Person(k+1)\fam[i]
    Next i
    Person(k)\inf=Person(k+1)\inf
  Next k
  ;
  perzahl-1
  If perzahl>0
    For k=1 To perzahl
      StrukturInDaten(k)  ; damit in Liste() sortiert werden kann
    Next k
  EndIf
  Liste()
  If ab=1
    Initialisierung()
  EndIf
  ; Kein NeuDim() !
EndProcedure ; Entfernen
;
Procedure VirtEntfernen()
  pz=perzahl
  For i=1 To pz
    If (Left(Person(i)\nam,5)="ZZZZZ") And (Person(i)\vat[0]=0) And (Person(i)\fam[0]=0)
      Entfernen(i,0)
    EndIf
  Next i
EndProcedure ; VirtEntfernen
;
Procedure HinWeg(typ)
  weg=typ
  Select weg
    Case 0
      txt$="Hinzufgen: Personenliste und freies Feld anklicken - "
      txt$+"bernehmen: Verbindungen anzeigen/Programmende"
    Case 1
      txt$+"Entfernen: Besetztes Feld anklicken - "
      txt$+"bernehmen: Verbindungen anzeigen/Programmende"
  EndSelect
  SetGadgetState(2,-1)
  pgad=0
  Hilfe(0,txt$)
EndProcedure ; HinWeg
;
Procedure Sortierung(typ)
  sort=typ
  SetGadgetState(296+sort,1)  
  Liste()
  If pgad>0
    VerbindungenAnzeigen(prs(5))
  EndIf
EndProcedure ; Sortierung
;
;- HILFSPROZEDUREN
Procedure.i Zyklentest(p)
  vor(1)=p
  For i=1 To 255
    vor(2*i)=Person(vor(i))\vat[0]
    vor(2*i+1)=Person(vor(i))\mut[0]
  Next i
  For i=2 To 511
    If vor(i)=vor(1)
      zyk=vor(i)
      Break
    EndIf
  Next i
  zykl=zyk
  ProcedureReturn zyk
EndProcedure ; Zyklentest
;
Procedure.s NNnummer()
  nn=1
  For k=1 To perzahl
    p$=Person(k)\nam
    If Left(p$,2)="NN"
      n=Val(Mid(p$,4,Len(p$)-4))
      If n>nn-1
        nn=n+1
      EndIf
    EndIf
  Next k
  nnn$="NN("+Str(nn)+")"
  ProcedureReturn nnn$
EndProcedure ; NNnummer
;
Procedure.s ZZnummer()
  zz=1
  For k=1 To perzahl
    p$=Person(k)\nam
    If Left(p$,5)="ZZZZZ"
      z=Val(Mid(p$,7,Len(p$)-7))
      If z>zz-1
        zz=z+1
      EndIf
    EndIf
  Next k
  zzz$="ZZZZZ("+Str(zz)+")"
  ProcedureReturn zzz$
EndProcedure ; ZZnummer
;
Procedure.s Prueftext()
  prf$=GetGadgetText(251)
  prf$+GetGadgetText(252)
  prf$+GetGadgetText(253)
  prf$+GetGadgetText(254)
  prf$+Str(GetGadgetState(255))
  prf$+Str(GetGadgetState(256))
  ProcedureReturn prf$
EndProcedure ; Prueftext
;
Procedure.i Datentest()
  If perzahl<>perzahlstart
    ProcedureReturn 1
  EndIf
  For k=1 To perzahl
    If datenstart$(k)<>daten$(k)
      ProcedureReturn 1
    EndIf
  Next k
EndProcedure ; Datentest
;
Procedure.s Parse(f$,typ=0)
  Select typ
    Case 0 ; Ascii-Codes ersetzen
      If FindString(f$,"{",1)=0
        ProcedureReturn f$
      EndIf
      fvor$=f$
      tit$="Eingabefehler"
      While FindString(f$,"{",1)>0
        kla=FindString(f$,"{",klz+1)
        klz=FindString(f$,"}",kla+1)
        If klz=0
          txt$="Term "+fvor$+":    "
          txt$+Chr(13)+Chr(13)
          txt$+"Klammern {...} fehlerhaft.    "
          MessageRequester(tit$,txt$,#MB_ICONSTOP)
          ProcedureReturn #fehler
        EndIf
        ch1$=Mid(f$,kla+1,klz-kla-1)
        ac=Val(ch1$)
        If (ac<32) Or (ac>255)
          txt$="Term "+fvor$+":    "
          txt$+Chr(13)+Chr(13)
          txt$+"Code "+ch1$+" nicht brauchbar.    "
          MessageRequester(tit$,txt$,#MB_ICONSTOP)
          ProcedureReturn #fehler
        EndIf
        If (ac=123) Or (ac=125)
          txt$="Term "+fvor$+":    "
          txt$+Chr(13)+Chr(13)
          txt$+"Code "+Str(ac)+" fr das Zeichen "+Chr(ac)+Space(4)
          txt$+Chr(13)
          txt$+"kann nicht verwendet werden.    "
          MessageRequester(tit$,txt$,#MB_ICONSTOP)
          ProcedureReturn #fehler
        EndIf
        ch2$=Mid(f$,kla,klz-kla+1)
        f$=ReplaceString(f$,ch2$,Chr(ac))
      Wend
      If FindString(f$,"{",1) Or FindString(f$,"}",1)
        txt$="Term "+fvor$+":    "
        txt$+Chr(13)+Chr(13) 
        txt$+"Klammern {...} fehlerhaft.   "
        MessageRequester(tit$,txt$,#MB_ICONSTOP)
        ProcedureReturn #fehler
      EndIf
      ProcedureReturn f$  
    Case 1 ; Namensvorstze (von, ...) entfernen
      ac=Asc(Left(f$,1))
      If (ac<65) Or (ac>90)
        Repeat
          ai+1
          ac=Asc(Mid(f$,ai,1)) 
        Until ((ac>64) And (ac<91)) Or (ai=100)
        If ai<>100
          f$=ReplaceString(f$,Left(f$,ai-1),"")
        EndIf
      EndIf
      ProcedureReturn f$
    Case 2 ; ersten Namen oder Vornamen ermitteln
      lz=FindString(f$," ",1)
      If lz>0
        f$=Left(f$,lz-1)
      EndIf
      lz=FindString(f$,"-",1)
      If lz>0
        f$=Left(f$,lz-1)
      EndIf
      ProcedureReturn f$
    Case 3 ; Namensteil bis zum 1. Leerzeichen oder - nach 1. Grobuchstaben ermitteln
      Repeat
        ai+1
        ac=Asc(Mid(f$,ai,1)) 
      Until ((ac>65) And (ac<90)) Or (ai=100)
      If ai<>100
        aj=ai
        Repeat
          aj+1
          ac=Asc(Mid(f$,aj,1)) 
        Until (ac=32) Or (ac=45) Or (aj=100)
        If aj<>100
          f$=Left(f$,aj-1)
        EndIf     
      EndIf
      ProcedureReturn f$
  EndSelect  
EndProcedure ; Parse
;  
Procedure.s GetFileName(f$)
  ProcedureReturn Left(GetFilePart(f$),Len(GetFilePart(f$))-Len(GetExtensionPart(f$))-1)
EndProcedure ; GetFileName
;
Procedure.i Max(x,y)
  If x>y
    max=x
  Else
    max=y
  EndIf
  ProcedureReturn max
EndProcedure ; Max
;
Procedure.i Min(x,y)
  If x<y
    min=x
  Else
    min=y
  EndIf
  ProcedureReturn min
EndProcedure ; Min
;
;- INFO-HILFE
Procedure Info()
  lizenz1$="Copyright  "+Chr(169)+"  Dr. Arnim Wegner"
  lizenz2$="GNU General Public License"
  lizenz3$=" ist freie Software, die Sie unter bestimmten Bedingungen"
  lizenz4$="weitergeben drfen; lesen Sie Lizenz.pdf und Handbuch.pdf fr Details."
  lizenz5$="Fr "
  lizenz6$=" besteht KEINERLEI GARANTIE;"
  lizenz7$="lesen Sie Lizenz.pdf und Handbuch.pdf fr Details."
  lizenz8$=" is free software, and you are welcome to redistribute it"
  lizenz9$="under certain conditions; for details read Lizenz.pdf and Handbuch.pdf."
  lizenz10$=" comes with ABSOLUTELY NO WARRANTY;"
  lizenz11$="for details read Lizenz.pdf and Handbuch.pdf."
  txt$=Space(45)+programmtitel$+Chr(13)+Chr(13)
  txt$+Space(30)+lizenz1$+Chr(13)+Chr(13)+Chr(13)
  txt$+Space(34)+lizenz2$+Chr(13)+Chr(13)
  txt$+Space(6)+programmtitel$+lizenz3$+Space(8)+Chr(13)
  txt$+Space(5)+lizenz4$+Chr(13)
  txt$+Space(21)+lizenz5$+programmtitel$+lizenz6$+Chr(13)
  txt$+Space(19)+lizenz7$+Chr(13)+Chr(13)
  txt$+Space(7)+programmtitel$+lizenz8$+Chr(13)
  txt$+Space(4)+lizenz9$+Chr(13)
  txt$+Space(16)+programmtitel$+lizenz10$+Chr(13)
  txt$+Space(22)+lizenz11$+Chr(13)
  MessageRequester(programmtitel$,txt$,#PB_MessageRequester_Ok)
EndProcedure ; Info
;
Procedure Hilfe(typ,txt$="")
  Select typ
    Case 0
      StatusBarText(0,0,txt$,#PB_StatusBar_Raised|#PB_StatusBar_Center)
    Case 1
      tit$="Handbuch ffnen"
      txt$=OpenFileRequester(tit$,hnd$,"PDF-Dateien|*.pdf|Alle Dateien|*.*",0)
      If txt$=""
        ProcedureReturn
      ElseIf FileSize(txt$)<0
        txt1$="Eine Textdatei "+GetFilePart(txt$)+" existiert nicht.    "
        MessageRequester(tit$,txt1$,#MB_ICONSTOP)
        ProcedureReturn
      Else
        If RunProgram(txt$)=0
          tit$="Dateifehler"
          txt3$="Die Datei "+GetFilePart(txt$)+" konnte nicht geffnet werden.    "
          MessageRequester(tit$,txt3$,#MB_ICONSTOP)
        EndIf
      EndIf
    Case 2
      txt$="Programmverzeichnis:"
      txt$+Chr(13)
      txt$+pfad$+Space(4)
      txt$+Chr(13)+Chr(13)
      txt$+"Anwendungsdatenverzeichnis:"
      txt$+Chr(13)
      txt$+appdat$+Space(4)
      txt$+Chr(13)+Chr(13)
      txt$+"Anwendungsdatenverzeichnis der vorhergehenden Programmversion:    "
      txt$+Chr(13)
      If appdatalt$=appenv$
        txt$+"Nicht gefunden."
      Else  
        txt$+appdatalt$+Space(4)
      EndIf  
      MessageRequester(programmtitel$,txt$,#MB_ICONINFORMATION)
  EndSelect 
EndProcedure ; Hilfe
;
;-####################################### Programmende #####################################